// Real Ray Tracer
// Taken from Persistence of Vision Raytracer

/* This file contains the following new declared shapes :
     Square_X,Square_Y,Square_Z
     Tetrahedron,Pyramid,Hexagon
     Octahedron,Dodecahedron,Icosahedron
     HalfCone_Y
*/

#declare SquareX = parallelogram { <0 -0.5 -0.5> <0 -0.5 0.5> <0 0.5 -0.5> }

#declare SquareY = parallelogram { <-0.5 0 -0.5> <-0.5 0 0.5> <0.5 0 -0.5> }

#declare SquareZ = parallelogram { <-0.5 -0.5 0> <-0.5 0.5 0> <0.5 -0.5 0> }

#declare Tetrahedron = intersection {
  intersection {
    plane { <0.0 -1.0 0.0> 0.5 }
    plane { <0.0 0.0 -1.0> 0.5 rotate <19.47 0.0 0.0> }
  }
  intersection {
    plane { <0.0 0.0 -1.0> 0.5 rotate <19.47 -120.0 0.0> }
    plane { <0.0 0.0 -1.0> 0.5 rotate <19.47 120.0 0.0> }
  }
}

#declare Pyramid = intersection {
  intersection {
    intersection {
      plane { <1 0 0> 0.5  rotate <0 0 40> }
      plane { <-1 0 0> 0.5 rotate <0 0 -40> }
    }
    intersection {
      plane { <0 0 1> 0.5  rotate <-40 0 0> }
      plane { <0 0 -1> 0.5 rotate <40 0 0> }
    }
  }
  plane { <0 -1 0> 0 }
}

/* Hexagonal Solid, axis along x */
#declare Hexagon = intersection {
  intersection {
    slab { <0.0 0.0 1.0> -0.5 0.5  }
    slab { <0.0 0.0 1.0> -0.5 0.5 rotate <60.0 0.0 0.0> }
  }
  intersection {
    slab { <0.0 0.0 1.0> -0.5 0.5 rotate <120.0 0.0 0.0> }
    slab  { <1.0 0.0 0.0> -0.5 0.5 }
  }
}

#declare Octahedron = intersection {
  intersection {
    slab { <0.0 0.0 1.0> -0.5 0.5 rotate <35.264 0.0 0.0> }
    slab { <0.0 0.0 1.0> -0.5 0.5 rotate <-35.264 0.0 0.0> }
  }
  intersection {
    slab { <1.0 0.0 0.0> -0.5 0.5 rotate <0.0 0.0 -35.264> }
    slab { <1.0 0.0 0.0> -0.5 0.5 rotate <0.0 0.0 35.264> }
  }
}

#declare Dodecahedron = intersection {
  intersection {
    intersection {
      intersection {
        plane { <0.0 0.0 -1.0> 0.5 rotate <-26.565 0.0 0.0> }
        plane { <0.0 0.0 -1.0> 0.5 rotate <-26.565 -72.0 0.0> }
      }
      intersection {
        plane { <0.0 0.0 -1.0> 0.5 rotate <-26.565 -144.0 0.0> }
        plane { <0.0 0.0 -1.0> 0.5 rotate <-26.565 -216.0 0.0> }
      }
    }

    intersection {
      intersection {
        plane { <0.0 0.0 -1.0> 0.5 rotate <-26.565 -288.0 0.0> }
        plane { <0.0 0.0 -1.0> 0.5 rotate <26.565 -36.0 0.0> }
      }
      intersection {
        plane { <0.0 0.0 -1.0> 0.5 rotate <26.565 -108.0 0.0> }
        plane { <0.0 0.0 -1.0> 0.5 rotate <26.565 -180.0 0.0> }
      }
    }
  }

  intersection {
    intersection {
      plane { <0.0 0.0 -1.0> 0.5 rotate <26.565 -252.0 0.0> }
      plane { <0.0 0.0 -1.0> 0.5 rotate <26.565 -324.0 0.0> }
    }
    slab { <0.0 1.0 0.0> -0.5 0.5 }
  }
}

#declare Icosahedron = intersection {
  intersection {
    intersection {
      intersection {
        plane { <0.0 0.0 -1.0> 1.0 rotate <52.6625 0.0 0.0> }
        plane { <0.0 0.0 -1.0> 1.0 rotate <52.6625 -72.0 0.0> }
      }
      intersection {
        plane { <0.0 0.0 -1.0> 1.0 rotate <52.6625 -144.0 0.0> }
        plane { <0.0 0.0 -1.0> 1.0 rotate <52.6625 -216.0 0.0> }
      }
    }
    intersection {
      intersection {
        plane { <0.0 0.0 -1.0> 1.0 rotate <52.6625 -288.0 0.0> }
        plane { <0.0 0.0 -1.0> 1.0 rotate <10.8125 0.0 0.0> }
      }
      intersection {
        plane { <0.0 0.0 -1.0> 1.0 rotate <10.8125 -72.0 0.0> }
        plane { <0.0 0.0 -1.0> 1.0 rotate <10.8125 -144.0 0.0> }
      }
    }
  }
  intersection {
    intersection {
      intersection {
        intersection {
          plane { <0.0 0.0 -1.0> 1.0 rotate <10.8125 -216.0 0.0> }
          plane { <0.0 0.0 -1.0> 1.0 rotate <10.8125 -288.0 0.0> }
        }
        intersection {
          plane { <0.0 0.0 -1.0> 1.0 rotate <-52.6625 -36.0 0.0> }
          plane { <0.0 0.0 -1.0> 1.0 rotate <-52.6625 -108.0 0.0> }
        }
      }
      intersection {
        intersection {
          plane { <0.0 0.0 -1.0> 1.0 rotate <-52.6625 -180.0 0.0> }
          plane { <0.0 0.0 -1.0> 1.0 rotate <-52.6625 -252.0 0.0> }
        }
        intersection {
          plane { <0.0 0.0 -1.0> 1.0 rotate <-52.6625 -324.0 0.0> }
          plane { <0.0 0.0 -1.0> 1.0 rotate <-10.8125 -36.0 0.0> }
        }
      }
    }
    intersection {
      intersection {
        plane { <0.0 0.0 -1.0> 1.0 rotate <-10.8125 -108.0 0.0> }
        plane { <0.0 0.0 -1.0> 1.0 rotate <-10.8125 -180.0 0.0> }
      }
      intersection {
        plane { <0.0 0.0 -1.0> 1.0 rotate <-10.8125 -252.0 0.0> }
        plane { <0.0 0.0 -1.0> 1.0 rotate <-10.8125 -324.0 0.0> }
      }
    }
  }
}

#declare HalfCone_Y = intersection {
   quadric { // QCone_Y
      <1.0 -1.0 1.0>
      <0.0  0.0 0.0>
      <0.0  0.0 0.0>
       0.0
   }
   slab { <0 1 0 > -2 0 }
   translate <0 1 0>
   scale <0.5 1 0.5>
}

end.
