PROGRAM DemoEvents;
USES CRT, EVENTS, GRAPH;
TYPE tTextSettings = RECORD
                       Font     : Word;
                       Dir      : Word;
                       Size     : Word;
                       Horiz    : Word;
                       Vert     : Word;
                       Color    : Byte;
                     END;
CONST
     PathDriverBGI      = 'C:\BP\BGI';
     cTitre             : tTextSettings = (Font: 8;Dir:0;Size:1;Horiz:0;vert:2;Color:11);
     cDev               : tTextSettings = (Font: 6;Dir:0;Size:1;Horiz:0;vert:2;Color:15);
     cAppel             : tTextSettings = (Font: 6;Dir:0;Size:1;Horiz:0;vert:2;Color:10);
     cCode              : tTextSettings = (Font: 0;Dir:0;Size:1;Horiz:0;vert:2;Color: 7);
     cNote              : tTextSettings = (Font: 6;Dir:0;Size:1;Horiz:0;vert:2;Color:13);

     cStatusLine : Array [0..3] of String[100] = (
          'ENTER ou Bouton gauche pour continuer, ESC pour Quitter',
          'ENTER ou Bouton gauche pour excuter la commande, ESC pour Quitter',
          'ENTER pour continuer, ESC pour Quitter',
          'ENTER pour excuter la commande, ESC pour Quitter');

VAR
     MaxX, MaxY         : Word;
     X, Y               : Word;
     CH                 : Char;
     CurrentTextStyle   : tTextSettings;

{ͻ}
{ͼ}
PROCEDURE Son(Freq,Duree:word);
begin
sound(freq);delay(duree);nosound;
end;

{ͻ}
{ͼ}
PROCEDURE FinProgramme;
BEGIN
CloseGraph;
Halt;
END;

{ͻ}
{ͼ}
PROCEDURE WaitToGo;
var
  Ch : char;
begin
  ch:=#0;
  Son(500,100);Son(300,80);
  repeat
    if keypressed then ch := readkey;
  until LeftButtonPress or (ch=#27) or (ch=#13);
  if Ch = #27 then FinProgramme;
end;

{ͻ}
{ͼ}
function Int2Str(L : LongInt) : string;
var
  S : string;
begin
  Str(L, S);
  Int2Str := S;
end;

{ͻ}
{ͼ}
PROCEDURE TextStyle(St : tTextSettings);
BEGIN
  With St do
  BEGIN
    SetTextStyle(Font,Dir,Size);
    SetTextJustify(Horiz,Vert);
    SetColor(Color);
  END;
  CurrentTextStyle := St;
END;

{ͻ}
{ͼ}
PROCEDURE DrawBorder;
var
  ViewPort : ViewPortType;
begin
  SetColor(14);
  SetLineStyle(SolidLn, 0, NormWidth);
  GetViewSettings(ViewPort);
  with ViewPort do
    Rectangle(0, 0, x2-x1, y2-y1);
end;

{ͻ}
{ͼ}
PROCEDURE MainWindow;
Begin
  SetColor(14);
  SetTextStyle(DefaultFont, HorizDir, 1);
  SetTextJustify(CenterText, TopText);
  SetViewPort(0, 0, MaxX, MaxY, ClipOn);
  SetViewPort(0, 60, MaxX, MaxY-(TextHeight('M')+6), ClipOn);
  HideMouse;
  ClearViewPort;
  DrawBorder;
  ShowMouse;
  SetViewPort(1, 61, MaxX-1, MaxY-(TextHeight('M')+9), ClipOn);
  y := 0;
end;

{ͻ}
{ͼ}
PROCEDURE StatusLine( St: Byte);
Begin
  SetViewPort(0, 0, MaxX, MaxY, ClipOn);
  SetColor(14);
  SetTextStyle(DefaultFont, HorizDir, 1);
  SetTextJustify(CenterText, TopText);
  SetLineStyle(SolidLn, 0, NormWidth);
  SetFillStyle(1, 7);
  HideMouse;
  Bar(0, MaxY-(TextHeight('M')+4), MaxX, MaxY);
  Rectangle(0, MaxY-(TextHeight('M')+4), MaxX, MaxY);
  SetColor(8);
  OutTextXY(MaxX div 2, MaxY-(TextHeight('M')+2), cStatusLine[St]);
  SetColor(14);
  OutTextXY(MaxX div 2+1, MaxY-(TextHeight('M')+1), cStatusLine[St]);
  ShowMouse;
  SetViewPort(1, 61, MaxX-1, MaxY-(TextHeight('M')+7), ClipOn);
  TextStyle(CurrentTextStyle);
end;

{ͻ}
{ͼ}
PROCEDURE WriteOut(x:Word;S : string);
begin
  If S<>'' then OutTextXY(X, Y, S);
  Inc(Y, TextHeight('M')+2);
end;
{ͻ}
{ͼ}
PROCEDURE Wln;
BEGIN
  Inc(Y, TextHeight('M')+2);
END;
{ͻ}
{ͼ}
PROCEDURE WriteTitre(s:String);
Begin
  TextStyle(cTitre);
  WriteOut(10,s);
  TextStyle(cDev);
  Wln;
End;
{ͻ}
{ͼ}
PROCEDURE dInitMouse;
BEGIN
  If not InitMouse then
  begin
    CloseGraph;
    TextAttr := 12;
    Writeln('Souris absente ! ou driver non install');
    halt;
  End;
  MainWindow;
  WriteTitre('1. Fonction InitMouse.');
  WriteOut(10,'Pour initialiser la souris on utilise la fonction InitMouse. Cette fonction retourne ');
  WriteOut(10,'la valeur True si le driver souris a pu tre correctement initialis.');
  WriteOut(10,'Dans le cas contraire, la fonction retourne FALSE. ');
  WriteOut(10,'Si c''est le cas, vrifiez si vous avez charg le driver souris en mmoire. ');
  WriteOut(10,'En gnral, MOUSE.SYS dans le fichier CONFIG.SYS ou MOUSE.COM dans le ');
  WriteOut(10,'fichier AUTOEXEC.BAT ou  l''invite MS-DOS.');
  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'IF NOT InitMouse THEN');
  WriteOut(20,'  BEGIN');
  WriteOut(20,'    Writeln(''Souris absente ! ou driver non install'');');
  WriteOut(20,'    Halt;');
  WriteOut(20,'  END;');
  TextStyle(cNote);
  Wln;
  WriteOut(10,'Note : La fonction InitMouse met  jour les variables Info^.NbButton et');
  WriteOut(10,'       Info^.NbButtonStr. Voir les programmes d''exemples pour plus d''informations');
  WriteOut(10,'       sur la procdure UpDateInfo et la variable Info.');
  StatusLine(0);
  WaitToGo;
END;

{ͻ}
{ͼ}
PROCEDURE dShowMouse;
BEGIN
  MainWindow;
  WriteTitre('2. Procdures ShowMouse et HideMouse.');
  WriteOut(10,'La souris est maintenant initialise. Mais o est le curseur ...?!');
  WriteOut(10,'En fait, aprs initialisation, le curseur n''est pas visible. Pour le rendre visible');
  WriteOut(10,'on utilise la fonction ShowMouse. Elle  pour simple effet d''activer le curseur.');
  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'ShowMouse;');
  StatusLine(1);
  WaitToGo;

  TextStyle(cDev);
  Wln;
  WriteOut(10,'Pour faire disparaitre le curseur, on utilise la procdure HideMouse.');
  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'HideMouse;');
  ShowMouse;
  WaitToGo;

  HideMouse;
  TextStyle(cNote);
  Wln;
  WriteOut(10,'Note : Vous devez cacher le curseur de la souris pour chaque sortie cran. Sinon,');
  WriteOut(10,'       des choses bizarres vont apparaitre sur l''cran.');
  WriteOut(10,'       Si vous excutez 2 fois la procdure ShowMouse, il faudra excuter');
  WriteOut(10,'       2 fois la procedure HideMouse pour cacher le curseur (et vice-versa).');
  StatusLine(0);
  WaitToGo;
  ShowMouse;
END;

{ͻ}
{ͼ}
PROCEDURE dReadMouse;
VAR cxX, cxY, cY, vx, vy  : Word;
    cxRX, cxRY            : Word;
    cxB, cyLB, cyMB, CYRB : Word;
    vlb, vmb, vrb         : Boolean;
BEGIN
  HideMouse;
  MainWindow;
  WriteTitre('3. Procdures ReadMouse et ReadMouseMove (1/2).');
  WriteOut(10,'La procdure ReadMouse permet de lire la position du curseur et l''tat des');
  WriteOut(10,'boutons de la souris. La position du curseur est disponible dans les variables');
  WriteOut(10,'Mouse.X et Mouse.Y. L''tat des boutons et indiqu par les 3 variables');
  WriteOut(10,'boolennes LeftButton, MiddleButton et RightButton. Ces variables ont la');
  WriteOut(10,'valeur TRUE si leur bouton respectifs sont enfoncs. La variable AnyButton  la');
  WriteOut(10,'valeur TRUE si au moins un des boutons est enfonc.');
  WriteOut(10,'Pour lire constament la position du curseur et l''tat des boutons, il faut');
  WriteOut(10,'excuter la procdure ReadMouse constament.');
  WriteOut(10,'La procdure ReadMouseMove dtermine le distance entre la position actuelle');
  WriteOut(10,'du curseur et la position du curseur lors du dernier appel de cette fonction.');
  WriteOut(10,'Les variables Mouse.RX et Mouse.RY contiennent la valeur du dplacement. Des');
  WriteOut(10,'valeurs positives indiquent un dplacement vers le bas ou la droite de l''cran');
  WriteOut(10,'alors que des valeurs ngatives indiquent un dplacement vers le haut ou la');
  WriteOut(10,'gauche de l''cran.');
  StatusLine(0);
  ShowMouse;
  WaitToGo;
{ Page 2 }
  HideMouse;
  MainWindow;
  WriteTitre('3. Procdures ReadMouse et ReadMouseMove (2/2).');
  TextStyle(cAppel);
  WriteOut(10,'Exemple :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'Repeat');
  WriteOut(20,'  ReadMouse;');
  WriteOut(20,'  { Instructions... }');
  WriteOut(20,'Until AnyButton;');
  TextStyle(cDev);
  Wln;

  SetColor(15);
  X:=30;
  cY  := y;

  OutTextXY(X,Y,'X : ');
  cxX := x + TextWidth('X : ');
  x := x +   TextWidth('X : 888 ');

  OutTextXY(X,Y,'Y : ');
  cxY := x + TextWidth('Y : ');
  x := x +   TextWidth('Y : 888     ');

  OutTextXY(X,Y,'dX : ');
  cxRx := x + TextWidth('dX : ');
  x := x +    TextWidth('dX : -111 ');

  OutTextXY(X,Y,'dY : ');
  cxRY := x + TextWidth('dY : ');

  Wln;
  Wln;

  cyLB := y;
  WriteOut(20,'Bouton gauche :');
  cyMB := y;
  WriteOut(20,'Bouton milieu :');
  cyRB := y;
  WriteOut(20,'Bouton droit  :');
  Wln;
  TextStyle(cNote);
  WriteOut(10,'Note : X et Y reprsentent les coordonnes du curseur.');
  WriteOut(10,'       dX et dY reprsentent le dplacement du curseur. dX et dY sont mis  jour');
  WriteOut(10,'        chaque pression du bouton gauche de la souris. (Dans l''exemple)');
  WriteOut(10,'       Les valeurs dX et dY ne sont pas fournies en points mais en mickeys.');
  WriteOut(10,'       (1 mickey quivant  1/200 de pouce).');

  cxB := 20 + TextWidth('Bouton gauche : ');

  StatusLine(2);
  ShowMouse;
  TextStyle(cDev);

  Repeat
  ReadMouse;

  if Mouse.x <>vx then
  begin
  HideMouse;
  SetColor(0);
  OutTextXY(cxX,cy,'');
  SetColor(13);
  OutTextXY(cxX,cY,Int2Str(Mouse.X));
  vx:=Mouse.x;
  ShowMouse;
  end;

  if Mouse.y <>vy then
  begin
  HideMouse;
  SetColor(0);
  OutTextXY(cxY,cy,'');
  SetColor(13);
  OutTextXY(cxY,cY,Int2Str(Mouse.Y));
  vy := Mouse.y;
  ShowMouse;
  end;

  if (vlb <>leftbutton) or (vmb <>middlebutton) or (vrb<>rightbutton) then
  begin
  HideMouse;
  SetColor(13);
    SetFillStyle(1,0);
    Bar(cxb,cylb,cxb+textwidth('Enfonc '),cyRB+textheight('M'));
    If LeftButton then
    Begin
      OutTextXY(cxb,cyLB,'Enfonc');
      readMouseMove;
      SetColor(0);
      OutTextXY(cxRX,CY,'');
      OutTextXY(cxRY,CY,'');
      SetColor(13);
      OutTextXY(cxRX,CY,Int2str(Mouse.rx));
      OutTextXY(cxRY,CY,int2str(Mouse.ry));

    End
      else OutTextXY(cxb,cyLB,'Relach');
    If MiddleButton then OutTextXY(cxb,cyMB,'Enfonc') else OutTextXY(cxb,cyMB,'Relach');
    If RightButton then OutTextXY(cxb,cyRB,'Enfonc') else OutTextXY(cxb,cyRB,'Relach');
    vlb:=leftbutton;
    vmb :=middlebutton;
    vrb := RightButton;
    ShowMouse;
  end;
  if keypressed then ch:=readkey;
  Until (ch=#27) or (ch=#13);
  ch:=#0;

END;

{ͻ}
{ͼ}
PROCEDURE dSetMousePosition;
BEGIN
  HideMouse;
  MainWindow;
  WriteTitre('4. Procdure SetMousePosition.');
  WriteOut(10,'La procdure SetMousePosition permet de dfinir la position du curseur de la');
  WriteOut(10,'souris. Deux paramtres sont ncessaire  cette procdure. Le premier est la');
  WriteOut(10,'coordonn en X du curseur et le deuxime la coordonn en Y.');
  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'SetMousePosition (10,10);');
  TextStyle(cNote);
  Wln;
  WriteOut(10,'Note : Il n''est pas ncessaire de cacher le curseur de la souris pour dfinir une');
  WriteOut(10,'       position du curseur. Les coordonnes du curseur sont disponibles dans les');
  WriteOut(10,'       variables Mouse.X et Mouse.Y. Ces variables sont mises  jour par la');
  WriteOut(10,'       procdure READMOUSE et par le gestionnaire d''vnement s''il est install.');
  StatusLine(0);
  ShowMouse;
  LeftButtonPress;
  Repeat
    SetMousePosition(Random(MaxX),Random(MaxY));
    Delay(1000);
    If KeyPressed then Ch := ReadKey;
  Until LeftButtonPress or (ch=#27) or (ch=#13);
  if ch=#27 then FinProgramme;
  ch:=#0;
END;

{ͻ}
{ͼ}
PROCEDURE dMousePress;
BEGIN
  HideMouse;
  MainWindow;
  WriteTitre('5. Procdures MousePress et MouseRelease (1/2).');
  WriteOut(10,'Les procdures MOUSEPRESS et MOUSERELEASE permettent de dterminer');
  WriteOut(10,'combien de fois un bouton de la souris a t, respectivement, enfonc');
  WriteOut(10,'ou relach depuis le dernier appel de ces fonctions.');
  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'Function LeftButtonPress : Boolean;');
  WriteOut(20,'  Var Count : Word;');
  WriteOut(20,'Begin');
  WriteOut(20,'  MousePress ( cLeftButton, Count );');
  WriteOut(20,'  LeftButtonPress := ( Count = 1 );');
  WriteOut(20,'End;');
  TextStyle(cNote);
  Wln;
  WriteOut(10,'Note : La fonction ci-dessus renvoie TRUE si le bouton gauche a t press.');
  WriteOut(10,'       Le premier paramtre indique le bouton  "tester". On peut utiliser les 3');
  WriteOut(10,'       constantes cLEFTBUTTON, cMIDDLEBUTTON, cRIGHTBUTTON. Le deuxime');
  WriteOut(10,'       paramtre est une variable de type WORD qui va recevoir le nombre de fois');
  WriteOut(10,'       que le bouton a t enfonc.');
  WriteOut(10,'       On procde de la mme manire avec la procdure MOUSERELEASE.');
  StatusLine(0);
  ShowMouse;
  WaitToGo;
{ Page 2 }
  HideMouse;
  MainWindow;
  WriteTitre('5. Procdures MousePress et MouseRelease (2/2).');
  WriteOut(10,'6 fonction sont dfinies dans l''unit EVENTS.PAS : LEFTBUTTONPRESS,');
  WriteOut(10,'MIDDLEBUTTONPRESS, RIGHTBUTTONPRESS, LEFTBUTTONRELEASE,');
  WriteOut(10,'MIDDLEBUTTONRELEASE et RIGHTBUTTONRELEASE.');
  Wln;
  WriteOut(10,'Essayez de cliquer les boutons de la souris. Chaque fois que vous enfoncerez un');
  WriteOut(10,'bouton, un son grave sera mit. Un son plus aigu sera reproduit  chaque fois');
  WriteOut(10,'que vous relacherez un bouton.');
  TextStyle(cNote);
  Wln;
  WriteOut(10,'Note : Les 6 fonctions dfinies mettent  jour les coordonnes du curseur, c''est');
  WriteOut(10,'        dire, les variables Mouse.X et Mouse.Y.');
  StatusLine(2);
  ShowMouse;
  LeftButtonPress; MiddleButtonPress; RightButtonPress;
  LeftButtonRelease; MiddleButtonRelease; RightButtonRelease;
  Repeat
  readmouse;
  if leftbuttonpress or middlebuttonpress or rightbuttonpress
    then Son(200,200);
  if leftbuttonrelease or middlebuttonrelease or rightbuttonrelease
    then son(600,200);
  if keypressed then ch:=readkey;
  Until (ch=#27) or (ch=#13);
  ch:=#0;
END;

{ͻ}
{ͼ}
PROCEDURE dSetMouseBound;
BEGIN
  hidemouse;
  Mainwindow;
  writeTitre('6. Procdures SetMouseBoundX,Y et Set,GetMouseArea (1/3).');
  WriteOut(10,'La procdure SETMOUSEBOUNDX permet de fixer la zone de dplacement');
  WriteOut(10,'horizontale du curseur de la souris. Vous l''aurez compris, la procdure');
  WriteOut(10,'SETMOUSEBOUNDY fixe la zone de dplacement verticale et la procdure');
  WriteOut(10,'SETMOUSEAREA et une combinaison des deux prcdentes fonctions.');

  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'SetMouseBoundX ( 0, 50 );');
  Wln;
  TextStyle(cDev);
  WriteOut(10,'La ligne ci-dessus limite les dplacements horizontaux entre la colonne 0 et 50.');
  StatusLine(1);
  ShowMouse;
  WaitToGo;
  SetMouseBoundX(0,50);

  HideMouse;
  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'SetMouseBoundY ( 0, 100 );');
  Wln;
  TextStyle(cDev);
  WriteOut(10,'La ligne ci-dessus limite les dplacements verticaux entre la ligne 0 et 100.');
  ShowMouse;
  WaitToGo;
  SetMouseBoundY(0,100);

  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'SetMouseArea ( 0, 0, 50, 100 );');
  Wln;
  TextStyle(cDev);
  WriteOut(10,'La ligne ci-dessus quivaut aux 2 lignes prcdentes.');
  StatusLine(0);
  ShowMouse;
  WaitToGo;
{ Page 2 }
  Hidemouse;
  Mainwindow;
  writeTitre('6. Procdures SetMouseBoundX,Y et Set,GetMouseArea (2/3).');
  WriteOut(10,'Pour rendre sa libert au curseur, vous devez spcifier un zone englobant tout');
  WriteOut(10,'l''cran.');
  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'SetMouseArea ( 0, 0, GetMaxX, GetMaxY );');
  Wln;
  StatusLine(1);
  ShowMouse;
  WaitToGo;
  SetMouseArea(0,0,MaxX,MaxY);

  HideMouse;
  TextStyle(cNote);
  WriteOut(10,'Note : Si le curseur de la souris se trouve en dehors de la zone spcifie, il y');
  WriteOut(10,'       est automatiquement ramen par le driver de la souris.');
  WriteOut(10,'       Pour la procdure SETMOUSEAREA, les 2 premiers nombres indiquent la');
  WriteOut(10,'       coordonne du coin suprieure gauche de la zone et les 2 autres, le coin');
  WriteOut(10,'       infrieure droit.');
  TextStyle(cDev);
  Wln;
  WriteOut(10,'La procdure GetMouseArea retourne la zone de dplacement actuelle.');
  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'GetMouseArea ( x1, y1, x2, y2 );');
  StatusLine(0);
  ShowMouse;
  WaitToGo;
{ Page 3 }
  HideMouse;
  MainWindow;
  writeTitre('6. Procdures SetMouseBoundX,Y et Set,GetMouseArea (1/3).');
  WriteOut(10,'Les 4 variables sont de type WORD. Les variables X1 et Y1 reprsentent le coin');
  WriteOut(10,'suprieur gauche de la zone de dplacement, X2 et Y2 le coin infrieure droit.');
  Wln;
  WriteOut(10,'Dans l''tat actuel, les variables auraient les valeurs 0, 0, '+Int2Str(MaxX)+
              ', '+Int2Str(MaxY)+'.');
  ShowMouse;
  WaitToGo;
END;

{ͻ}
{ͼ}
PROCEDURE dSetMouseCursor;
BEGIN
  HideMouse;
  MainWindow;
  WriteTitre('7. Procdure SetMouseCursor (1/4).');
  WriteOut(10,'La procdure SETMOUSECURSOR permet de modifier l''apparance du curseur en');
  WriteOut(10,'mode graphique. Un paramtre est  fournir : le nom de la constante de');
  WriteOut(10,'type tCurseur qui dfini le curseur.');
  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'SetMouseCursor ( fDroite );');
  StatusLine(1);
  ShowMouse;
  WaitToGo;
  SetMouseCursor ( fDroite );

  HideMouse;
  TextStyle(cDev);
  WriteOut(10,'Le type tCurseur est dfinie comme suit :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'TYPE tCurseur = RECORD');
  WriteOut(20,'                  PtRefx, PtRefy : Word;');
  WriteOut(20,'                  Dessin         : Array [0..15] of String[16];');
  WriteOut(20,'                END;');
  Wln;
  TextStyle(cDev);
  WriteOut(10,'-PtRefx et PtRefy reprsentent la coordonne du Hot-Spot du curseur.');
  WriteOut(10,'C''est en fait les coordonnes du point qui determine la position');
  WriteOut(10,'exacte du curseur. Vous pouvez obtenir ces coordonnes grce  la procdure');
  WriteOut(10,'GetCursorHotSpot explique dans les pages suivantes.');
  WriteOut(10,'-Dessin reprsente le dessin du curseur dont la taille et de 16x16 pixels.');
  WriteOut(10,'Vous pouvez dfinir vos propres curseur par des constantes de type tCurseur.');
  StatusLine(0);
  ShowMouse;
  WaitToGo;
{ Page 2 }
  HideMouse;
  MainWindow;
  WriteTitre('7. Procdure SetMouseCursor (2/4).');
  TextStyle(cAppel);
  WriteOut(10,'Dfinition du curseur fDroite :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'FDroite : tCurseur =');
  WriteOut(20,'                       ( PtRefX : 16;');
  WriteOut(20,'                         PtRefY : 8;');
  WriteOut(20,'                         Dessin:     (''                '',');
  WriteOut(20,'                                      ''         0      '',');
  WriteOut(20,'                                      ''         00     '',');
  WriteOut(20,'                                      ''         010    '',');
  WriteOut(20,'                                      ''         0110   '',');
  WriteOut(20,'                                      ''00000000001110  '',');
  WriteOut(20,'                                      ''011111111111110 '',');
  WriteOut(20,'                                      ''0111111111111110'',');
  WriteOut(20,'                                      ''011111111111110 '',');
  WriteOut(20,'                                      ''00000000001110  '',');
  WriteOut(20,'                                      ''         0110   '',');
  WriteOut(20,'                                      ''         010    '',');
  WriteOut(20,'                                      ''         00     '',');
  WriteOut(20,'                                      ''         0      '',');
  WriteOut(20,'                                      ''                '',');
  WriteOut(20,'                                      ''                ''));');
  Wln;
  TextStyle(cDev);
  WriteOut(10,'Dans la dfinition du curseur, 4 caractres sont admis :');
  WriteOut(10,' '' '' : N''affiche rien du tout.');
  WriteOut(10,' ''0'' : Affiche toujours un point noir.');
  WriteOut(10,' ''1'' : Affiche (pas toujours) un point blanc.');
  WriteOut(10,' ''2'' : Affiche TOUJOURS un point de couleur invers.');
  StatusLine(0);
  ShowMouse;
  WaitToGo;
{ Page 3 }
  HideMouse;
  MainWindow;
  WriteTitre('7. Procdure SetMouseCursor (3/4).');
  WriteOut(10,'Le caractre ''1'' n''affiche pas toujours un point blanc car une procdure');
  WriteOut(10,'est dfinie. C''est la procdure SetMouseTransparent. Cette procdure rend tous');
  WriteOut(10,'les ''1'' quivalents  des ''2'' et redfini le curseur. Ce qui a pour effet de rendre');
  WriteOut(10,'le curseur ''transparent''.');
  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'SetMouseTransparent ( True );');
  StatusLine(1);
  ShowMouse;
  WaitToGo;

  SetMouseTransparent ( True );
  HideMouse;
  TextStyle(cDev);
  Wln;
  WriteOut(10,'Observez l''effet de cette procdure en dplacent le curseur de la souris sur');
  WriteOut(10,'diffrente partie de l''cran.');
  WriteOut(10,'');
  WriteOut(10,'Une valeur TRUE passe en paramtre  la procdure SetMouseTransparent rend');
  WriteOut(10,'le curseur transprent. La valeur FALSE le redessine plein. Si dans la dfinition');
  WriteOut(10,'du curseur des ''2'' sont mis  la place des ''1'', le curseur sera toujours');
  WriteOut(10,'transparent et la procdure SetMouseTranparent n''a aucun effet.');
  StatusLine(0);
  ShowMouse;
  WaitToGo;
{ Page 4 }
  HideMouse;
  MainWindow;
  WriteTitre('7. Procdure SetMouseCursor (4/4).');
  WriteOut(10,'La procdure GetCursorHotSpot permet d''obtenir les coordonnes du Hot-Spot.');
  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'GetCursorHotSpot ( x , y );');
  Wln;
  TextStyle(cDev);
  WriteOut(10,'Les variables X et Y sont du type ShortInt. Elles reoivent respectivement la');
  WriteOut(10,'coordonne en X et Y du Hot-Spot. Dans le cas prsent, les variables X et Y');
  WriteOut(10,'ont pour valeur 16 et 8 ( correspond au bout de la flche ).');
  StatusLine(0);
  ShowMouse;
  WaitToGo;
  SetMouseCursor(fStandart);
END;

{ͻ}
{ͼ}
{$F+}
PROCEDURE MyRoutine ( a,b,c,d : Word);
BEGIN
  Sound(Mouse.X); Delay(10); NoSound;
END;
{$F-}
PROCEDURE dInstallInterrupt;
BEGIN
  HideMouse;
  MainWindow;
  WriteTitre('8. Procdure InstallInterrupt (1/4).');
  WriteOut(10,'Cette routine permet  un programme d''installer un gestionnaire d''vnements,');
  WriteOut(10,'qui sera appel lorsqu''interviendra un vnement dtermin concernant la souris.');
  WriteOut(10,'L''unique paramtre  passer est le masque d''vnements, c''est  dire, les');
  WriteOut(10,'vnements qui devront dclancher l''appel du gestionnaire d''vnements.');
  WriteOut(10,'Ce paramtre est de type WORD, mais il est plus simple d''utiliser les constantes');
  WriteOut(10,'dfinies.');
  TextStyle(cAppel);
  WriteOut(10,'Constantes :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'cEvMove          = 1   : La souris a t dplace.');
  Wln;
  WriteOut(20,'cEvLeftPress     = 2   : Bouton gauche enfonc.');
  WriteOut(20,'cEvLeftRelease   = 4   : Bouton gauche relach.');
  WriteOut(20,'cEvRightPress    = 8   : Bouton droit enfonc.');
  WriteOut(20,'cEvRightRelease  = 16  : Bouton droit relach.');
  WriteOut(20,'cEvMiddlePress   = 32  : Bouton central enfonc.');
  WriteOut(20,'cEvMiddleRelease = 64  : Bouton central relach.');
  Wln;
  WriteOut(20,'cEvAllPress      = 42  : Un des boutons enfonc.');
  WriteOut(20,'cEvAllRelease    = 84  : Un des boutons relach.');
  WriteOut(20,'cEvAll           = 127 : Un de tous les vnements prcdents.');
  Wln;
  TextStyle(cDev);
  WriteOut(10,'Vous pouvez combiner chaques constantes dfinies en les additionnants.');
  StatusLine(0);
  ShowMouse;
  WaitToGo;
{ Page 2 }
  HideMouse;
  MainWindow;
  WriteTitre('8. Procdure InstallInterrupt (2/4).');
  WriteOut(10,'L''appel de la procdure InstallInterrupt se fait de la manire suivante.');
  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'InstallInterrupt ( cEvAllPress + cEvMouve );');
  Wln;
  StatusLine(1);
  ShowMouse;
  WaitToGo;
  InstallInterrupt( cEvAllPress + cEvMove );

  HideMouse;
  TextStyle(cDev);
  WriteOut(10,'Maintenant que le gestionnaire d''vnements est install,  chaque dplacement');
  WriteOut(10,'de la souris ou  chaque pression de l''un des boutons, le gestionnaire sera');
  WriteOut(10,'appell. Ce gestionnaire met  jour les variables Mouse.X et Mouse.Y ( position');
  WriteOut(10,'du curseur de la souris), LeftButton, MiddleButton et RightButton ( tat des');
  WriteOut(10,'boutons ), Mouse.RX et Mouse.RY ( dplacement de la souris ).');
  Wln;
  WriteOut(10,'Le gestionnaire d''vnements peut appeller une de vos routines dfinie de la');
  WriteOut(10,'manire suivante.');
  TextStyle(cAppel);
  WriteOut(10,'Dfiniton de la routine :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'{$F+}');
  WriteOut(20,'PROCEDURE MyRoutine ( Event, Button, cX, cY : Word );');
  WriteOut(20,'BEGIN');
  WriteOut(20,'  { Instructions ... }');
  WriteOut(20,'END;');
  WriteOut(20,'{$F-}');
  StatusLine(0);
  ShowMouse;
  WaitToGo;
{ Page 3 }
  HideMouse;
  MainWindow;
  WriteTitre('8. Procdure InstallInterrupt (3/4).');
  WriteOut(10,'Une fois que votre procdure est dfinie, vous devez dclarer la prsence d''une');
  WriteOut(10,'routine utilisateur au moyen de la procdure SetUserEventHandler de la manire');
  WriteOut(10,'suivante.');
  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'SetUserEventHandler ( MyRoutine );');
  Wln;
  StatusLine(1);
  ShowMouse;
  WaitToGo;
  SetUserEventHandler ( MyRoutine );

  HideMouse;
  TextStyle(cDev);
  WriteOut(10,'Maintenant, chaque fois que le gestionnaire d''vnements est appell, il appelle');
  WriteOut(10,'la routine MyRoutine qui mt un Bip.');
  Wln;
  WriteOut(10,'Pour annuler l''appel de votre routine, le nom de la routine  passer en paramtre');
  WriteOut(10,'est : NoUserEventHandler.');
  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'SetUserEventHandler ( NoUserEventHandler );');
  Wln;
  StatusLine(1);
  ShowMouse;
  WaitToGo;
  SetUserEventHandler ( NoUserEventHandler );
  HideMouse;
  StatusLine(0);
  ShowMouse;
  WaitToGo;
{ Page 4 }
  HideMouse;
  MainWindow;
  WriteTitre('8. Procdure InstallInterrupt (4/4).');
  TextStyle(cNote);
  WriteOut(10,'Note : La procdure MyRoutine DOIT absolument tre dclare FAR. Soit en');
  WriteOut(10,'       incluant les directives de compilation {$F+} et {$F-} ou en indiquant la');
  WriteOut(10,'       commande FAR aprs la dclaration de la procdure.');
  WriteOut(10,'       La procdure MyRoutine DOIT possder en paramtre 4 variables de type');
  WriteOut(10,'       WORD qui prendront respectivement, l''vnement qui a dclench l''appel,');
  WriteOut(10,'       l''tat des boutons de la souris, ainsi que la position horizontale et');
  WriteOut(10,'       verticale de la souris.');
  WriteOut(10,'       Pour enlever le gestionnaire d''vnement, il faut rinitialiser la souris');
  WriteOut(10,'        l''aide de la fonction InitMouse.');
  TextStyle(cDev);
  Wln;
  WriteOut(10,'Pour changer de masque d''vnements, on utilise la fonction ChangeInterrupt de la');
  WriteOut(10,'mme manire que la procdure InstallInterrupt.');
  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'ChangeInterrupt ( cEvAllRelease );');
  StatusLine(0);
  ShowMouse;
  WaitToGo;
END;

{ͻ}
{ͼ}
PROCEDURE dSetMouseSpeed;
BEGIN
  HideMouse;
  MainWindow;
  WriteTitre('9. Procdures SetMouseRatio et SetDoubleSpeed (1/3).');
  WriteOut(10,'La procdure SetMouseRatio dfinit le rapport entre les mickeys et les points,');
  WriteOut(10,'dont dpend la sensibilit de la souris du point de vue utilisateur, C''est  dire');
  WriteOut(10,'la vitesse avec laquelle le curseur de la souris peut tre dplac sur l''cran.');
  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'SetMouseRatio ( 100, 100 );');
  Wln;
  StatusLine(1);
  ShowMouse;
  WaitToGo;
  SetMouseRatio ( 100, 100 );

  HideMouse;
  textstyle(cNote);
  WriteOut(10,'Note : les 2 paramtres correspondent  la sensibilit X et Y. Ils doivents tre');
  WriteOut(10,'       compris entre 0 et 32767. A 32767, le curseur ne bouge plus,  0');
  WriteOut(10,'       il est incontrolable.');
  WriteOut(10,'       La fonction InitMouse remet les valeurs par dfaut qui sont 8 et 16.');
  StatusLine(0);
  ShowMouse;
  WaitToGo;

{ Page 2 }
  HideMouse;
  MainWindow;
  WriteTitre('9. Procdures SetMouseRatio et SetDoubleSpeed (2/3).');
  WriteOut(10,'La procdure SetDoubleSpeed fixe le seuil pour le doublement de la vitesse de la');
  WriteOut(10,'souris.');
  WriteOut(10,'Explications : Si la vitesse de dplacement de la souris dpasse un seuil');
  WriteOut(10,'determin, le driver de la souris double le rapport entre les points et les mickeys,');
  WriteOut(10,'de faon  doubler la vitesse de la souris. Cette routine permet de fixer le seuil');
  WriteOut(10,'au-del duquel ce doublement intervient.');
  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'SetDoubleSpeed ( 5000 );');
  Wln;
  StatusLine(1);
  ShowMouse;
  WaitToGo;
  SetDoubleSpeed(5000);

  HideMouse;
  TextStyle(cNote);
  WriteOut(10,'Note : A partir de 5000, la vitesse ne peut plus tre ,en pratique, atteinte');
  WriteOut(10,'       ce qui a pour effet d''empcher tout doublement de la vitesse de la');
  WriteOut(10,'       souris.');
  Showmouse;
  StatusLine(0);
  WaitToGo;
{ Page 3 }
  HideMouse;
  MainWindow;
  WriteTitre('9. Procdures SetMouseRatio et SetDoubleSpeed (3/3).');
  WriteOut(10,'La procdure SetMouseSensitivity permet de rgler la sensibilit de la souris.');
  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(10,'SetMouseSensitivity ( 10, 10, 50);');
  Wln;
  textstyle(cNote);
  WriteOut(10,'Note : Les 3 valeurs transmises doivent tre comprises en 0 et 100. Elles');
  WriteOut(10,'       reprsentent la sensibilit en X, Y et le doublement de vitesse.');
  Wln;
  textstyle(cDev);
  WriteOut(10,'La procdure GetMouseSensitivity renvoie les paramtres qui ont t fixs par la');
  WriteOut(10,'procdure prcdente.');
  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(10,'GetMouseSensitivity ( SpeedX, SpeedY, Seuil);');
  Wln;

  textstyle(cNote);
  WriteOut(10,'Note : Les 3 variables doivent tre du type WORD.');
  StatusLine(0);
  ShowMouse;
  WaitToGo;
  InitMouse;
  ShowMouse;
END;

{ͻ}
{ͼ}
PROCEDURE dSetMouseExclusionArea;
BEGIN
  HideMouse;
  MainWindow;
  WriteTitre('10. Procdure SetMouseExclusionArea.');
  WriteOut(10,'Cette routine permet  un programme de dfinir une zone quelconque de l''cran');
  WriteOut(10,'comme zone d''exclusion, qui aura pour effet de faire disparatre de curseur de');
  WriteOut(10,'la souris de l''cran ds qu''il pntrera cette zone.');
  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'SetMouseExclusionArea ( 0, 0, 640, 60 );');
  Wln;
  StatusLine(1);
  ShowMouse;
  WaitToGo;
  HideMouse;
  StatusLine(0);
  ShowMouse;
  SetMouseExclusionArea ( 0, 0, MaxX, 60 );
  WaitToGo;

  If CursorVisible then HideMouse;
  TextStyle(cDev);
  WriteOut(10,'Les 2 premiers paramtres correspondent aux coordonnes du coin suprieur');
  WriteOut(10,'gauche, les 2 autres au coin infrieur droit.');
  WriteOut(10,'Les routines InitMouse ou ShowMouse annulent le zone d''exclusion.');
  StatusLine(0);
  ShowMouse;
  WaitToGo;
END;

{ͻ}
{ͼ}
PROCEDURE dSetInterruptRate;
BEGIN
  HideMouse;
  MainWindow;
  WriteTitre('11. Procdure SetInterruptRate.');
  WriteOut(10,'Cette procdure dtermine  quelle frquence l''lectronique de la souris lit la');
  WriteOut(10,'position actuelle de la souris et l''tat des boutons de la souris pour les');
  WriteOut(10,'retransmettre au driver de la souris.');
  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'SetInterruptRate ( 2 );');
  Wln;
  TextStyle(cNote);
  WriteOut(10,'Note : Les valeurs admises sont : 0 = Pas d''interruption');
  WriteOut(10,'                                     1 =   30 Hz');
  WriteOut(10,'                                     2 =   50 Hz');
  WriteOut(10,'                                     3 = 100 Hz');
  WriteOut(10,'                                     4 = 200 Hz');
  WriteOut(10,'       Vous pouvez obtenir la frquence d''interruption actuelle par la procdure');
  WriteOut(10,'       GetGeneralInformation.');
  SetColor(12);
  WriteOut(10,'       Cette routine n''est valide que pour les souris raccordes sur un port');
  WriteOut(10,'       souris.');
  StatusLine(0);
  ShowMouse;
  WaitToGo;
END;

{ͻ}
{ͼ}
PROCEDURE dSetMousePage;
BEGIN
  HideMouse;
  MainWindow;
  WriteTitre('12. Procdures Set... et GetMousePage.');
  WriteOut(10,'La procdure SetMousePage fixe la page cran dans laquelle le driver de la souris');
  WriteOut(10,'doit afficher le curseur de la souris tandis que la fonction GetMousePage retourne');
  WriteOut(10,'la page cran dans laquelle est affich le curseur.');
  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'SetMousePage ( 1 );');
  Wln;
  WriteOut(20,'WriteLn(''Page actuelle : '', GetMousePage );');
  Wln;
  TextStyle(cNote);
  WriteOut(10,'Note : La fonction GetMousePage retourne une valeur de type BYTE.');
  StatusLine(0);
  ShowMouse;
  WaitToGo;
END;

{ͻ}
{ͼ}
PROCEDURE dDisableMouseDriver;
BEGIN
  HideMouse;
  MainWindow;
  WriteTitre('13. Fonctions Disable... et EnableMouseDriver.');
  WriteOut(10,'La fonction DisableMouseDriver dsactive le driver actuel de la souris. Lorsque');
  WriteOut(10,'cette fonction est appelle, le driver souris libre toutes les routines');
  WriteOut(10,'d''interruption qu''il avait install lors de son activation. La fonction retourne');
  WriteOut(10,'la valeur TRUE si l''opration s''est bien effectue.');
  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'If Not DisableMouseDriver Then');
  WriteOut(20,'  WriteLn(''Impossible de dsactiver le driver de la souris.'');');
  Wln;
  StatusLine(1);
  ShowMouse;
  WaitToGo;
  DisableMouseDriver;

  HideMouse;
  TextStyle(cDev);
  WriteOut(10,'La fonction EnableMouseDriver ractive le driver souris dsactiv auparavant');
  WriteOut(10,'avec la fonction prcdente et retourne la valeur TRUE si le driver est bien');
  WriteOut(10,'reactiv.');
  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'If Not EnableMouseDriver Then');
  WriteOut(20,'  WriteLn(''Impossible de ractiver le driver de la souris.'');');
  Wln;
  StatusLine(3);
  ShowMouse;
  WaitToGo;
  EnableMouseDriver;

  HideMouse;
  StatusLine(0);
  ShowMouse;
  WaitToGo;
END;

{ͻ}
{ͼ}
PROCEDURE dMouseSoftWareReset;
BEGIN
  HideMouse;
  MainWindow;
  WriteTitre('14. Fonctions MouseSoftwareReset et MouseHardwareReset.');
  WriteOut(10,'La fonction MouseSoftwareReset effectue un reset logiciel du driver de la souris.');
  WriteOut(10,'Elle cache le curseur de la souris, dsactive les gestionnaires d''vnements');
  WriteOut(10,'dj installs et retourne la valeur TRUE si tout c''est bien pass.');
  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'If Not MouseSoftwareReset then');
  WriteOut(20,'       then WriteLn(''Reset logiciel chou.'');');
  Wln;
  StatusLine(1);
  ShowMouse;
  WaitToGo;
  MouseSoftwareReset;

  If CursorVisible then HideMouse;
  TextStyle(cDev);
  WriteOut(10,'La fonction MouseHardwareReset effectue un reset de l''lectronique de la souris');
  WriteOut(10,'sans agir sur les paramtres logiciels tels que le masque de bits du curseur de la');
  WriteOut(10,'souris, le seuil de doublement de vitesse de la souris ou les courbes d''acclra-');
  WriteOut(10,'-tion et retourne la valeur TRUE si tout c''est bien pass.');
  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'If Not MouseHardwareReset then');
  WriteOut(20,'       then WriteLn(''Reset Hardware chou.'');');
  Wln;
  StatusLine(1);
  ShowMouse;
  WaitToGo;
  MouseHardwareReset;

  StatusLine(0);
  ShowMouse;
  WaitToGo;
END;

{ͻ}
{ͼ}
PROCEDURE dSetLanguage;
BEGIN
  HideMouse;
  MainWindow;
  WriteTitre('15. Procdures Set... et GetLanguage.');
  WriteOut(10,'La procdure SetLanguage permet de dfinir la langue trangre pour les');
  WriteOut(10,'messages.');
  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'SetLanguage ( 1 );');
  Wln;
  TextStyle(cDev);
  WriteOut(10,'La fonction GetLanguage retourne une chaine de caractre de la langue utilise');
  WriteOut(10,'par le driver de la souris.');
  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'WriteLn (''Langue du driver de la souris : '', GetLanguage);');
  Wln;
  TextStyle(cNote);
  WriteOut(10,'Note : Le paramtre pour la procdure SetLanguage doit tre compris entre 0 et');
  WriteOut(10,'       9, et correspond aux langues suivantes : Anglais, Franais, Nerlandais,');
  WriteOut(10,'       Allemand, Sudois, Finlandais, Espagnol, Portugais, Italien.');
  StatusLine(0);
  ShowMouse;
  WaitToGo;
END;

{ͻ}
{ͼ}
PROCEDURE dGetMaxBounds;
BEGIN
  HideMouse;
  MainWindow;
  WriteTitre('16. Procdure GetMaxBounds.');
  WriteOut(10,'Cette procdure permet la position maxi que peut atteindre le curseur de la souris.');
  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'GetMaxBounds ( MaxX, MaxY );');
  Wln;
  TextStyle(cNote);
  WriteOut(10,'Note : Les 2 variables doivent tre du type WORD.');
  StatusLine(0);
  ShowMouse;
  WaitToGo;
END;

{ͻ}
{ͼ}
PROCEDURE dGetMasks;
BEGIN
  HideMouse;
  MainWindow;
  WriteTitre('17. Procdure GetMasks.');
  WriteOut(10,'La procdure GetMasks permet d''obtenir les masques d''cran et de curseur du');
  WriteOut(10,'curseur logiciel ou la ligne de dpart et la ligne finale du curseur lectronique.');
  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'GetMaxBounds ( ScreenMask, CursorMask );');
  Wln;
  TextStyle(cNote);
  WriteOut(10,'Note : Les 2 variables doivent tre du type WORD.');
  WriteOut(10,'       Voir la procdure SetMouseTextCursor pour plus d''xplications sur les');
  WriteOut(10,'       masques d''cran et de curseur.');
  StatusLine(0);
  ShowMouse;
  WaitToGo;
END;

{ͻ}
{ͼ}
PROCEDURE dSetAccelerationProfiles;
BEGIN
  HideMouse;
  MainWindow;
  WriteTitre('18. Procdures Set... et GetAccelerationProfiles.');
  WriteOut(10,'La procdure SetAccelerationProfiles permet de charger l''une des 4 courbes');
  WriteOut(10,'d''acclration gres par le driver de la souris sur le plan interne.');
  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'SetAccelerationProfiles ( 2 );');
  Wln;

  TextStyle(cDev);
  WriteOut(10,'La fonction GetAccelerationProfiles retourne le numro de la courbe d''acclration');
  WriteOut(10,'actuelle.');
  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'WriteLn (''Courbe d''acclaration courante :'',GetAccelerationProfiles);');
  Wln;
  TextStyle(cNote);
  WriteOut(10,'Note : La valeur fournie  la procdure SetAccelerationProfiles doit tre comprise');
  WriteOut(10,'       entre 1 et 4.');
  WriteOut(10,'       La valeur retourn par la fonction GetAccelerationProfiles est du type');
  WriteOut(10,'       BYTE.');
  StatusLine(0);
  ShowMouse;
  WaitToGo;
END;

{ͻ}
{ͼ}
PROCEDURE dIsTrackBall;
BEGIN
  HideMouse;
  MainWindow;
  WriteTitre('19. Fonction IsTrackBall.');
  WriteOut(10,'La fonction IsTrackBall retourne la valeur TRUE si une souris stationnaire');
  WriteOut(10,'(TrackBall ou BallPoint) a t dtcte sur votre ordinateur.');
  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'If IsTrackBall then WriteLn(''TrackBall dtect.'')');
  WriteOut(20,'   else WriteLn(''Pas de TrackBall dtect.'');');
  Wln;
  StatusLine(0);
  ShowMouse;
  WaitToGo;
END;

{ͻ}
{ͼ}
PROCEDURE dGetIniFilePath;
BEGIN
  HideMouse;
  MainWindow;
  WriteTitre('20. Fonction GetIniFilePath.');
  WriteOut(10,'La fonction GetIniFilePath retourne une chaine de caractre contenant le chemin');
  WriteOut(10,'du fichier MOUSE.INI.');
  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'WriteLn (''Chemin de MOUSE.INI : '',GetIniFilePath);');
  Wln;
  TextStyle(cNote);
  WriteOut(10,'Note : La variable Info^.INIFilePath est mise  jour par la fonction GetIniFilePath.');
  StatusLine(0);
  ShowMouse;
  WaitToGo;
END;

{ͻ}
{ͼ}
PROCEDURE dGetActiveFunctions;
BEGIN
  HideMouse;
  MainWindow;
  WriteTitre('21. Fonction GetActiveFunctions.');
  WriteOut(10,'La fonction GetActiveFunctions permet de connatre toutes les fonctions');
  WriteOut(10,'reconnues depuis la fonction 25h.');
  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'WriteLn (''Fonctions reconnues : '',GetActiveFunctions);');
  Wln;
  TextStyle(cNote);
  WriteOut(10,'Note : La fonction retourne un mot (WORD) dont chaque bit reprsente une');
  WriteOut(10,'       fonction.');
  WriteOut(10,'       Le bit 15 reprsente la fonction 25h (du driver de souris), le bit 14 la');
  WriteOut(10,'       fonction 26h, le bit 13 la fonction 27h, ... bit 0 la fonction 33h.');
  StatusLine(0);
  ShowMouse;
  WaitToGo;
END;

{ͻ}
{ͼ}
PROCEDURE dGetMouseType;
BEGIN
  HideMouse;
  MainWindow;
  WriteTitre('22. Procdure GetMouseType.');
  WriteOut(10,'La procdure GetMouseType met  jour les variables Info^.DriverVersion,');
  WriteOut(10,'Info^.DriverVersionStr, Info^.MouseType, Info^.MouseTypeStr, Info^.IRQ et');
  WriteOut(10,'Info^.IRQStr qui reprsentent respectivement le numro de version du driver');
  WriteOut(10,'(REAL & STRING [4]), le type de souris (BYTE & STRING [40]) et le numro d''IRQ');
  WriteOut(10,'(BYTE & STRING [4]).');
  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'GetMouseType;');
  StatusLine(0);
  ShowMouse;
  WaitToGo;
END;

{ͻ}
{ͼ}
PROCEDURE dGetGeneralInformation;
BEGIN
  HideMouse;
  MainWindow;
  WriteTitre('23. Procdure GetGeneralInformation.');
  WriteOut(10,'La procdure GetGeneralInformation met  jour les variables Info^.DriverType,');
  WriteOut(10,'Info^.IntegratedType, Info^.CursorType, Info^.CursorTypeStr, Info^.InterruptRate,');
  WriteOut(10,'Info^.InterruptRateStr, Info^.NbMDD et Info^.NbMDDStr qui reprsentent');
  WriteOut(10,'respectivement le type de driver (STRING [13]), ??? (BOOLEAN), le type de cur-');
  WriteOut(10,'-seur (BYTE & STRING [20]), la frquence d''interruption de l''lectronique (BYTE &');
  WriteOut(10,'STRING [6]) et le compteur de MDD (BYTE & STRING [3]).');
  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'GetGeneralInformation;');
  StatusLine(0);
  ShowMouse;
  WaitToGo;
END;
{ͻ}
{ͼ}
PROCEDURE dSetCursorInfo;
BEGIN
  HideMouse;
  MainWindow;
  WriteTitre('24. Procdures Set... et GetCursorInfo (1/2).');
  WriteOut(10,'La procdure SetCurseurInfo permet de redfinir l''apparence du curseur.');
  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'SetCursorInfo(1,1,50,10,True);');
  Wln;
  StatusLine(1);
  ShowMouse;
  WaitToGo;
  SetCursorInfo(1,1,50,10,True);
  If CursorVisible then HideMouse;
  TextStyle(cNote);
  WriteOut(10,'Note : Les 5 paramtres sont, dans l''ordre : le style du curseur (0=Normal,');
  WriteOut(10,'       1=Invers et 2=Transparent), la taille du curseur (0=Petit, 1=Moyen et');
  WriteOut(10,'       2=Grand), le seuil  partir duquel le curseur change de taille (1  100),');
  WriteOut(10,'       le temps dont la taille du curseur reste change (1  100) et l''autorisation');
  WriteOut(10,'       de changer la taille du curseur automatiquement ( True ou False ).');
  Wln;
  WriteOut(10,'       Si la taille est fixe  0, le curseur sera du style dfini par le premier');
  WriteOut(10,'       paramtre. Si la taille est fixe  1 ou 2 et le changement de taille non');
  WriteOut(10,'       autoris, la taille du curseur sera toujours de la taille dfinie. Par');
  WriteOut(10,'       contre, s''il est autoris, le curseur sera petit et deviendra moyen ou');
  WriteOut(10,'       grand pendant le temps dfini si la vitesse de dplacement du curseur');
  WriteOut(10,'       dpasse le seuil dfini.');
  StatusLine(0);
  ShowMouse;
  WaitToGo;
  HideMouse;
  MainWindow;
  WriteTitre('24. Procdures Set... et GetCursorInfo (2/2).');
  TextStyle(cNote);
  WriteOut(10,'Note : Si le changement d''options c''est bien droul, le curseur de ma souris');
  WriteOut(10,'       est cach.');
  WriteOut(10,'       Pour simplifier les choses, 3 procdures sont dfinies : SetInverseCursor,');
  WriteOut(10,'       qui dfini un curseur inverse, SetTransparentCursor, qui dfini un curseur');
  WriteOut(10,'       transparent et SetNormalCursor qui redonne au curseur son apparence par');
  WriteOut(10,'       dfaut.');
  Wln;
  TextStyle(cDev);
  WriteOut(10,'La procdure GetCursorInfo met  jour les prcdents paramtres dans les');
  WriteOut(10,'variables Info^.CurStyle, Info^.CurSize, Info^.CurTreshold, Info^.CurFlag et');
  WriteOut(10,'Info^.CurDelay.');
  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'GetCursorInfo;');
  StatusLine(0);
  ShowMouse;
  WaitToGo;
  SetNormalCursor;
  ShowMouse;
END;
{ͻ}
{ͼ}
PROCEDURE dDriverState;
BEGIN
  HideMouse;
  MainWindow;
  WriteTitre('25. Procdures Save... et RestoreDriverState.');
  WriteOut(10,'La procdure SaveDriverState permet de sauvegarder tous les paramtres actuels');
  WriteOut(10,'dans un buffer dont la taille ncessaire est renvoye par la fonction GetBufferSize.');
  WriteOut(10,'Les procdures Save... et RestoreDriverState attendent en paramtre le nom du');
  WriteOut(10,'Buffer que vous aurez dclar dans votre programme.');
  TextStyle(cAppel);
  WriteOut(10,'Dclaration du buffer :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'VAR Buffer : Array [0..Taille] of Byte;');
  WriteOut(20,'{...}');
  WriteOut(20,'SaveDriverState ( Buffer );');
  WriteOut(20,'{...}');
  WriteOut(20,'RestoreDriverState ( Buffer );');
  Wln;
  TextStyle(cNote);
  WriteOut(10,'Note : Taille et le nombre retourn par la fonction GetBufferSize.');
  Wln;
  TextStyle(cDev);
  WriteOut(10,'Ces procdures peuvent tre utiles lorsque que vous excutez un programme ');
  WriteOut(10,'l''aide de la fonction EXEC, ainsi, quelles que soient les modifications');
  WriteOut(10,'intervenues  l''intrieur du programme appel, les paramtres de la souris');
  WriteOut(10,'seront fixs  leurs valeurs antrieures.');
  StatusLine(0);
  ShowMouse;
  WaitToGo;
END;
{ͻ}
{ͼ}
PROCEDURE dSetMouseTextCursor;
BEGIN
  HideMouse;
  MainWindow;
  WriteTitre('26. Procdures SetMouseTextCursor (1/2).');
  WriteOut(10,'Vous pouvez redfinir l''apparence du curseur en mode texte grce  cette');
  WriteOut(10,'procdure. 3 paramtres sont ncessaires : Le type de curseur, le masque');
  WriteOut(10,'d''cran et le masque de curseur.');
  WriteOut(10,'Il y a 2 types de curseur : logiciel ou lectronique. Dans le cas d''un curseur');
  WriteOut(10,'lectronique, le deuxime et troisime paramtre reprsentent la ligne de dpart');
  WriteOut(10,'et la ligne de fin du curseur.');
  TextStyle(cAppel);
  WriteOut(10,'Appel :');
  TextStyle(cCode);
  Wln;
  WriteOut(20,'{ Curseur lectronique }');
  WriteOut(20,'SetMouseTextCursor (1,13,14);');
  Wln;
  WriteOut(20,'{ Curseur logiciel }');
  WriteOut(20,'SetMouseTextCursor (0,Shl8(Ord''X''),Shl8(12+(3*16)));');
  Wln;
  TextStyle(cNote);
  WriteOut(10,'Note : Pour un curseur logiciel, le deuxime paramtre correspond au caractre');
  WriteOut(10,'       qui reprsente le curseur. Il faut utiliser la fonction SHL8 avec la fonction');
  WriteOut(10,'       ORD ou avec le code ASCII du caractre. Ou bien, mettre seulement la');
  WriteOut(10,'       constante cSameChar.');
  StatusLine(0);
  ShowMouse;
  WaitToGo;

  HideMouse;
  MainWindow;
  WriteTitre('26. Procdures SetMouseTextCursor (2/2).');
  TextStyle(cNote);
  WriteOut(10,'       Le 3me paramtre dfini la couleur du curseur. La encore, on doit utiliser');
  WriteOut(10,'       la fonction SHL8 avec l''attribut du curseur que l''on dfini comme la ');
  WriteOut(10,'       variable TextAttr de l''unit CRT ou bien, utiliser l''une des 4 constantes');
  WriteOut(10,'       suivantes : cSameColor, cInvColor, cSameColorBlink et cInvColorBlink.');
  Wln;
  WriteOut(10,'       Pour plus d''information voir le programme d''exemple fourni.');
  StatusLine(0);
  ShowMouse;
  WaitToGo;
END;
{ͻ}
{ͼ}
PROCEDURE InitModeGraphique;
VAR
 grDriver, grMode : Integer;
BEGIN
 grDriver := Detect;
 InitGraph(grDriver, grMode,PathDriverBGI);
 if GraphResult <> grOk then
 BEGIN
   textAttr := 12;
   Writeln('Impossible d''initialiser le mode graphique.');
   Halt;
 END;
 MaxX := GetMaxX;
 MaxY := GetMaxY;
 Randomize;
END;

PROCEDURE InitScreen;

CONST Str1 = 'Dmonstration de l''unit EVENTS.PAS';
      Str2 = 'Programme de BOLATRE Jean-Philippe. (c) 03/06/94';

BEGIN
  SetFillStyle(1,7);
  Bar(0,0,MaxX,55);
  SetColor(14);
  Rectangle(0,0,MaxX,55);

  SetTextStyle(3,0,4);
  SetTextJustify(1,1);
  SetColor(8);
  OutTextXY(MaxX DIV 2, 10,Str1);
  SetColor(14);
  OutTextXY(MaxX DIV 2+1, 10+1,Str1);

  SetTextStyle(3,0,1);
  SetColor(8);
  OutTextXY(MaxX DIV 2, 40,Str2);
  SetColor(9);
  OutTextXY(MaxX DIV 2+1, 40+1,Str2);
END;

BEGIN
InitModeGraphique;
InitScreen;
dInitMouse;
dShowMouse;
dReadMouse;
dSetMousePosition;
dMousePress;
dSetMouseBound;
dSetMouseCursor;
dInstallInterrupt;
dSetMouseSpeed;
dSetMouseExclusionArea;
dSetInterruptRate;
dSetMousePage;
dDisableMouseDriver;
dMouseSoftWareReset;
dSetLanguage;
dGetMaxBounds;
dGetMasks;
dSetAccelerationProfiles;
dIsTrackBall;
dGetIniFilePath;
dGetActiveFunctions;
dGetMouseType;
dGetGeneralInformation;
dSetCursorInfo;
dDriverState;
dSetMouseTextCursor;
FinProgramme;
END.