(****************************************************************************)
(*                                                                          *)
(*                   PROGRAMME DE TRAITEMENT DE GRAPHES                     *)
(*                        Gaston Le Grapheur V2.0                           *)
(*                                                                          *)
(*              Programmeurs : Balorin/Bassanese/Charpentier                *)
(*                                                                          *)
(*            (C)opyright 1994  B&B&C SoftWare Corporation Ltd              *)
(*                                                                          *)
(****************************************************************************)
{$N+,E+}
program gaston_le_grapheur;

uses graph,printer,crt,mickey;

type fenetre=record
             x1,y1,x2,y2:integer;
             end;
     abscisse=0..640;
     ordonnee=0..480;
     vertex='a'..'z';
     matrice_adjacence=array [vertex,vertex] of boolean;
     matrice_poids = array [vertex,vertex] of integer;
     graphe=record
            mat:matrice_adjacence;
            mat_poids : matrice_poids;
            maxsom:integer;
            abs:array [vertex] of abscisse;
            ord:array [vertex] of ordonnee
            end;
      marq=RECORD
             som:char;
             pds:integer;
           END;
      predecesseur=ARRAY [vertex] of marq;

const n=26;

var errors,stdptr,tracepoids:boolean;

(********************************* MAX **************************************)
function max(i,j : integer):integer;
begin
if i>j
then max:=i
else max:=j;
end;

(************************************** MIN *********************************)
function min(i,j : integer):integer;
begin
if i<j
then min:=i
else min:=j;
end;



(****************************************************************************)
(***************************** PARTIE GRAPHIQUE *****************************)
(****************************************************************************)

(******************************** INITGRAPHIC *******************************)
procedure initgraphic;
var graphpilote,graphmode,modeinf,modesup:integer;
begin
graphpilote:=detect;
initgraph(graphpilote,graphmode,'');
if graphresult<>grok
then halt(1);
getmoderange(graphpilote,modeinf,modesup);
setgraphmode(graphmode);
end;

(****************************** INITIALISATION ECRAN ************************)
procedure centre_texte(x1,y1,x2,y2:integer;texte:STRING);
begin
outtextxy(((x2-x1-textwidth(texte)) DIV 2)+x1+1,((y2-y1-textheight(texte))
         DIV 2)+y1+1,texte);
end;

(**************************** change de fenetre courante ********************)
procedure chgfencour(active : boolean);
begin
if active
then setfillstyle(1,blue)
else setfillstyle(1,lightgray);
floodfill(50,5,black);
setcolor(white);
centre_texte(0,0,639,19,'Gaston Le Grapheur V2.0');
end;

(************************* dessine icones ***********************************)
procedure dessine_icones;
begin
setcolor(black);
rectangle(19,25,38,43);    (** Creer Graphe **)
rectangle(40,25,59,43);    (** Ajouter Sommet **)
rectangle(61,25,80,43);    (** Enlever Sommet **)
rectangle(99,25,118,43);   (** Deplacer Sommet **)
rectangle(120,25,139,43);  (** Ajouter Arc **)
rectangle(141,25,160,43);  (** Enlever Arc **)
rectangle(183,25,223,43);  (** DFS **)
rectangle(225,25,265,43);  (** BFS **)
rectangle(267,25,307,43);  (** Kruskal **)
rectangle(309,25,349,43);  (** Prim **)
rectangle(351,25,391,43);  (** Dijkstra **)
rectangle(504,25,551,43);  (** Poids **)
rectangle(553,25,620,43);  (** Retrace **)
setfillstyle(1,lightgray);
floodfill(20,26,black);
floodfill(41,26,black);
floodfill(62,26,black);
floodfill(100,26,black);
floodfill(121,26,black);
floodfill(142,26,black);
floodfill(184,26,black);
floodfill(226,26,black);
floodfill(268,26,black);
floodfill(310,26,black);
floodfill(352,26,black);
floodfill(505,26,black);
floodfill(554,26,black);
setcolor(black);
centre_texte(19,25,38,43,'CG');
centre_texte(40,25,59,43,'AS');
centre_texte(61,25,80,43,'ES');
centre_texte(99,25,118,43,'DS');
centre_texte(120,25,139,43,'AA');
centre_texte(141,25,160,43,'EA');
centre_texte(183,25,223,43,'DFS');
centre_texte(225,25,265,43,'BFS');
centre_texte(267,25,307,43,'KRUS');
centre_texte(309,25,349,43,'PRIM');
centre_texte(351,25,391,43,'DIJK');
centre_texte(504,25,551,43,'POIDS');
centre_texte(553,25,620,43,'RETRACE');
end;

(******************************** init ecran ********************************)
procedure initecran;
begin
clearviewport;
setfillstyle(1,lightgray);
floodfill(0,0,1);
setcolor(black);
rectangle(0,0,639,479);
rectangle(0,0,639,19);
rectangle(0,19,639,48);
rectangle(639,0,620,19);
centre_texte(639,0,620,19,'I');
rectangle(0,0,19,19);
rectangle(5,8,14,10);
rectangle(0,459,639,479);
setfillstyle(1,white);
floodfill(50,20,black);
floodfill(50,460,black);
chgfencour(true);
dessine_icones;
end;

(****************************** BARRE D'INFOS *******************************)
procedure barre_info(texte : STRING);
begin
setcolor(white);
outtextxy(10,465,'');
setcolor(blue);
outtextxy(10,465,texte);
end;

(******************************** DEMANDER **********************************)
procedure demander(texte : STRING ; VAR ver : vertex);
var p:pointer;
    c:char;
begin
if not errors
then begin
     hidepointer;
     setpointerposition(450,35);
     end;
chgfencour(false);
getmem(p,imagesize(158,188,481,291));
getimage(158,188,481,291,p^);
if not errors
then begin
     showpointer;
     setpointershape(sablier1);
     end;
setcolor(black);
rectangle(158,188,480,290);
rectangle(158,188,481,291);
setfillstyle(1,white);
floodfill(160,190,black);
rectangle(158,188,480,208);
setfillstyle(1,blue);
if not errors
then begin
     showpointer;
     setpointershape(sablier2);
     end;
floodfill(160,190,black);
setcolor(white);
centre_texte(158,188,480,208,'Demande de Gaston');
setcolor(black);
centre_texte(158,208,480,290,texte);
if not errors
then begin
     showpointer;
     setpointershape(sablier3);
     end;
if keypressed
then begin
     c:=readkey;
     if c=#0
     then c:=readkey;
     end;
repeat
      c:=readkey;
until c in ['a'..'z'];
setcolor(blue);
centre_texte(158,260,480,290,c);
delay(800);
ver:=c;
if not errors
then begin
     hidepointer;
     setpointerposition(450,35);
     end;
putimage(158,188,p^,normalput);
chgfencour(true);
setlimits(1,638,1,478);
if not errors
then begin
     showpointer;
     setpointershape(standard);
     end;
freemem(p,imagesize(158,188,481,291));;
end;

(*************************** DEMANDER POIDS**********************************)
procedure demander_poids(texte : STRING ; VAR poids : integer);
var p:pointer;
    c:char;
    s:string;
begin
if not errors
then begin
     hidepointer;
     setpointerposition(450,35);
     end;
chgfencour(false);
getmem(p,imagesize(158,188,481,291));
getimage(158,188,481,291,p^);
if not errors
then begin
     showpointer;
     setpointershape(sablier1);
     end;
setcolor(black);
rectangle(158,188,480,290);
rectangle(158,188,481,291);
setfillstyle(1,white);
floodfill(160,190,black);
rectangle(158,188,480,208);
if not errors
then begin
     showpointer;
     setpointershape(sablier2);
     end;
setfillstyle(1,blue);
floodfill(160,190,black);
setcolor(white);
centre_texte(158,188,480,208,'Demande de Gaston');
setcolor(black);
centre_texte(158,208,480,290,texte);
if not errors
then begin
     showpointer;
     setpointershape(sablier3);
     end;
if keypressed
then begin
     c:=readkey;
     if c=#0
     then c:=readkey;
     end;
s:='';
repeat
      begin
      repeat
            c:=readkey;
      until (c in ['0'..'9']) or (c='-') or (ord(c)=13);
      if ord(c)<>13
      then begin
           s:=concat(s,c);
           setcolor(white);
           centre_texte(158,260,480,290,'');
           setcolor(blue);
           centre_texte(158,260,480,290,s);
           end;
      end
until ord(c)=13;
val(s,poids,poids);
delay(800);
if not errors
then begin
     hidepointer;
     setpointerposition(450,35);
     end;
putimage(158,188,p^,normalput);
chgfencour(true);
setlimits(1,638,1,478);
if not errors
then begin
     showpointer;
     setpointershape(reticule);
     end;
freemem(p,imagesize(158,188,481,291));;
end;

(********************************** info ************************************)
procedure info;
var p:pointer;
    c:char;
    ok,okb:boolean;
begin
if not errors
then begin
     hidepointer;
     setpointerposition(450,35);
     end;
chgfencour(false);
getmem(p,imagesize(158,188,481,341));
getimage(158,188,481,341,p^);
if not errors
then showpointer;
setcolor(black);
rectangle(158,188,480,340);
rectangle(158,188,481,341);
setfillstyle(1,white);
floodfill(160,190,black);
rectangle(158,188,480,208);
setfillstyle(1,blue);
floodfill(160,190,black);
setcolor(white);
centre_texte(158,188,480,208,'Au sujet de Gaston Le Grapheur');
setcolor(black);
centre_texte(158,218,480,228,'Les gniaux auteurs de Gaston sont : ');
centre_texte(158,230,480,240,'(in alphabetic order)');
centre_texte(158,254,480,264,'Laurent BALORIN');
centre_texte(158,266,480,276,'Gregory BASSANESE');
centre_texte(158,278,480,288,'Sylvain CHARPENTIER');
barre_info('Les bidouilleurs sont les meilleurs...');
setcolor(black);
rectangle(300,300,352,322);
rectangle(300,300,353,323);
setfillstyle(1,lightgray);
floodfill(301,301,black);
centre_texte(300,300,352,322,'OK');
okb:=false;
ok:=false;
if keypressed
then begin
     c:=readkey;
     if c=#0
     then c:=readkey;
     end;
if not errors
then begin
     stdptr:=true;
     setpointershape(standard);
     setpointerposition(159,275);
     setlimits(158,480,208,340);
     end;
repeat
      begin
      if keypressed
      then begin
           c:=readkey;
           if c=#0
           then c:=readkey
           else if upcase(c)='O'
                then ok:=true;
           end;
      if not errors
      then if mousein(300,300,352,322)
           then begin
                if buttonpressed(7)
                then begin
                     setpointershape(main2);
                     delay(250);
                     setpointershape(main);
                     delay(250);
                     ok:=true;
                     end;
                if not okb
                then begin
                     setpointershape(main);
                     okb:=true;
                     stdptr:=false;
                     end
                else begin
                     end
                end
      else if not stdptr
           then begin
                setpointershape(standard);
                stdptr:=true;
                okb:=false;
                end;
      end
until ok;
if not errors
then begin
     hidepointer;
     setpointerposition(450,35);
     end;
putimage(158,188,p^,normalput);
chgfencour(true);
setlimits(1,638,1,478);
if not errors
then showpointer;
freemem(p,imagesize(158,188,481,341));
barre_info('');
end;


(********************************* QUITTER **********************************)
procedure quit(var quitter:boolean);
var p:pointer;
    a:char;
    x:integer;
begin
x:=0;
a:='a';
quitter:=false;
if not errors
then begin
     hidepointer;
     setpointerposition(450,35);
     end;
chgfencour(false);
getmem(p,imagesize(218,188,421,291));
getimage(218,188,421,291,p^);
if not errors
then showpointer;
setcolor(black);
rectangle(218,188,420,290);
rectangle(218,188,421,291);
setfillstyle(1,white);
floodfill(220,190,black);
rectangle(218,188,420,208);
setfillstyle(1,blue);
floodfill(220,190,black);
setcolor(white);
centre_texte(218,188,420,208,'Quitter Gaston');
setcolor(black);
outtextxy(240,218,'Voulez-Vous Vraiment');
outtextxy(240,228,'      Quitter');
outtextxy(240,238,'Gaston Le Grapheur ?');
rectangle(238,258,290,280);
rectangle(238,258,291,281);
setfillstyle(1,lightgray);
floodfill(239,259,black);
centre_texte(238,258,290,280,'OUI');
rectangle(348,258,400,280);
rectangle(348,258,401,281);
floodfill(349,259,black);
centre_texte(348,258,400,280,'NON');
setfillstyle(1,lightgray);
floodfill(256,269,black);
floodfill(366,269,black);
randomize;
if not errors
then begin
     setpointerposition(320,269);
     setpointershape(standard);
     stdptr:=true;
     setlimits(218,420,208,290);
     repeat
           begin
           if mousein(239,259,289,279)
           then if stdptr
                then begin
                     setpointershape(tete_mort);
                     stdptr:=false;
                     end
                else begin
                     if random(18000)=20
                     then begin
                          setpointershape(tete_mort2);
                          delay(250);
                          setpointershape(tete_mort);
                          end
                     end
           else if mousein(349,259,399,279)
                then if stdptr
                     then begin
                          setpointershape(marque);
                          stdptr:=false;
                          end
                     else begin
                          end
                else if not stdptr
                     then begin
                          setpointershape(standard);
                          stdptr:=true;
                          end;
           if keypressed
           then a:=readkey;
           if ((mousein(239,259,289,279) and buttonpressed(7))
              or (a='O') or (a='o'))
           then begin
                setpointershape(tete_mort2);
                delay(250);
                setpointershape(tete_mort);
                delay(250);
                x:=1
                end
           else if ((mousein(349,259,399,279) and buttonpressed(7))
                   or (a='N') or (a='n'))
                then x:=2;
           end
     until x<>0;
     end
else repeat
           begin
           if keypressed
           then a:=readkey;
           case a of
                'O','o':x:=1;
                'N','n':x:=2;
                end;
           end
     until x<>0;
quitter:=(x=1);
if not errors
then begin
     hidepointer;
     setpointerposition(15,15);
     end;
putimage(218,188,p^,normalput);
if not quitter
then begin
     chgfencour(true);
     setlimits(1,638,1,478);
     end;
if not errors and not quitter
then showpointer;
freemem(p,imagesize(218,188,421,291));
end;

(****************************************************************************)
(**************************** PARTIE MATHEMATIQUE ***************************)
(****************************************************************************)

(******************************** CREER GRAPHE ******************************)
procedure creer_graphe(var g:graphe);
var z1,z2:vertex;
    p:integer;
    i:integer;
    car:char;
    command:vertex;
begin                                  {initialisation du graphe vide}
for z1:='a' to 'z' do
    begin
    g.abs[z1]:=0;
    g.ord[z1]:=0
    end;
randomize;
for z1:='a' to 'z' do
    for z2:='a' to 'z' do
        begin
        g.mat[z1,z2]:=false;           {fin d'initialisation}
        g.mat_poids[z1,z2]:=0;
        g.mat_poids[z2,z1]:=0;
        end;
repeat
      begin
      demander(' Nom du dernier sommet (a..z) : ',command);
      g.maxsom:=ord(command)-96;
      end
until (g.maxsom>=1) and (g.maxsom<=26);
for z1:='a' to chr(96+g.maxsom) do
    begin
    g.mat[z1,z1]:=true;
    g.abs[z1]:=25+35*random(18);
    g.ord[z1]:=70+33*random(12)
    end;
for z1:='a' to chr(96+g.maxsom-1) do
    for z2:=succ('a') to chr(96+g.maxsom) do
        begin
        if (random(4)=1)
        then begin
             g.mat_poids[z1,z2]:=random(10)+1;
             g.mat_poids[z2,z1]:=g.mat_poids[z1,z2];
             g.mat[z1,z2]:=true;
             g.mat[z2,z1]:=true
             end
        end
end;

(******************************** DESSINE POINT *****************************)
procedure dessine_point(x1,y1:integer;vert:vertex);
begin
setfillstyle(1,magenta);
setcolor(white);
circle(x1,y1,3);
floodfill(x1,y1,15);
setcolor(red);
outtextxy(x1-15,y1-3,vert)
end;

(******************************** DESSINER GRAPHE ***************************)
procedure dessiner_graphe(var g:graphe);
var z1,z2:vertex;
    i:integer;
    couleur:word;
    strtmp:string;
begin
if not errors
then begin
     hidepointer;
     end;
setcolor(lightgray);
centre_texte(0,440,639,450,'');
setfillstyle(1,lightgray);
bar(1,49,638,458);
setfillstyle(1,magenta);
for z1:='a' to chr(96+g.maxsom) do
    if g.mat[z1,z1]
    then dessine_point(g.abs[z1],g.ord[z1],z1);
for z1:='a' to chr(96+g.maxsom) do
    for z2:='a' to chr(96+g.maxsom) do
        if g.mat[z1,z2] and (z1<z2) and g.mat[z1,z1] and g.mat[z2,z2]
        then begin
             setcolor(blue);
             line(g.abs[z1],g.ord[z1],g.abs[z2],g.ord[z2]);
             str(g.mat_poids[z1,z2],strtmp);
             if tracepoids
             then begin
                  setcolor(lightcyan);
                  outtextxy(((max(g.abs[z1],g.abs[z2])-min(g.abs[z1],g.abs[z2]))
                           DIV 2 -8+min(g.abs[z1],g.abs[z2])),(max(g.ord[z1],
                           g.ord[z2])-min(g.ord[z1],g.ord[z2])) DIV 2 -8+
                           min(g.ord[z1],g.ord[z2]),strtmp);
                  end;
             end;
if not errors
then showpointer;
end;


(******************************** ARETE EPAISSE *****************************)
procedure arete_epaisse(var g:graphe;z1,z2:vertex);
var style : word;
begin
if not errors
then begin
     hidepointer;
     end;
style:=0;
setlinestyle(style,0,thickwidth);
setcolor(lightgreen);
line(g.abs[z1],g.ord[z1],g.abs[z2],g.ord[z2]);
setlinestyle(style,0,normwidth);
if not errors
then showpointer;
delay(300);
end;

procedure arete_epaisse_le_retour(x1,y1,x2,y2:integer);
var style : word;
begin
if not errors
then begin
     hidepointer;
     end;
style:=0;
setlinestyle(style,0,normwidth);
setcolor(lightgreen);
line(x1,y1,x2,y2);
setlinestyle(style,0,normwidth);
if not errors
then showpointer;
delay(100);
end;

(****************************************************************************)
(*********************** EXPLORATIONS DE GRAPHES ****************************)
(****************************************************************************)

(***************************** DFS RECURSIF *********************************)
procedure dfs_recursif(var g:graphe;racine:vertex);
var i:integer;
    arbre:string;
    dfi:array [vertex] of integer;
    z:vertex;
    car:char;

    (***************** DFS *****************)
    procedure dfs(v:vertex);
    var w:vertex;
    begin
    dfi[v]:=i;
    i:=i+1;
    for w:='a' to chr(96+g.maxsom) do
        if (dfi[w]=0) and (g.mat[w,v])
        then begin
             arbre:=arbre+w;
             arete_epaisse(g,v,w);
             dfs(w)
             end
    end;
    (***************************************)

begin                                            {dfs_recursif}
if not errors
then setpointershape(sablier1);
i:=1;
arbre:=racine;
for z:='a' to chr(96+g.maxsom) do
    dfi[z]:=0;
if not errors
then setpointershape(sablier2);
dfi[racine]:=1;                              {dfi[z]:=1;}
dfs(racine);
if not errors
then setpointershape(sablier3);
setcolor(white);
centre_texte(0,440,639,450,' Arbre obtenu par D.F.S. rcursif : '+arbre);
if not errors then setpointershape(standard);
end;

(************************************ BFS ***********************************)
procedure bfs(var g:graphe;racine:vertex);
var arbrecour, arbretot, arbresuiv : string;
    arbretemp, arbretemp2          : string;
    ver                            : vertex;
    niveau, longanc, maxnbpoints   : integer;
    gtemp                          : graphe;
    nbpoints, numpoint, nbpointstot: integer;

begin
if not errors
then setpointershape(sablier1);
setfillstyle(1,lightgray);
bar(1,49,638,458);
arbresuiv:='';
arbrecour:=racine;
arbretot:=racine;
niveau:=0;
gtemp.abs[racine]:=50+540 div 2;
gtemp.ord[racine]:=60+niveau*50;
dessine_point(gtemp.abs[racine],gtemp.ord[racine],racine);
longanc:=540;
nbpointstot:=1;
maxnbpoints:=1;
if not errors
then setpointershape(sablier2);
repeat
      begin
      racine:=arbrecour[1];
      delete(arbrecour,1,1);
      arbretemp2:='';
      for ver:='a' to 'z' do
          if (ver<>racine) and (g.mat[racine,ver]) and (pos(ver,arbretot)=0)
          then begin
               arbretemp2:=concat(arbretemp2,ver);
               arbresuiv:=concat(arbresuiv,ver);
               arbretot:=concat(arbretot,ver);
               end;
      nbpoints:=length(arbretemp2);
      arbretemp:=arbretemp2;
      numpoint:=1;
      while (length(arbretemp)<>0) do
            begin
            ver:=arbretemp[1];
            delete(arbretemp,1,1);
            gtemp.abs[ver]:=numpoint*(longanc div nbpoints)+gtemp.abs[racine]
                            -longanc div 2-(longanc div nbpoints) div 2;
            gtemp.ord[ver]:=60+(niveau+1)*70;
            dessine_point(gtemp.abs[ver],gtemp.ord[ver],ver);
            arete_epaisse_le_retour(gtemp.abs[racine],gtemp.ord[racine],
                                    gtemp.abs[ver],gtemp.ord[ver]);
            inc(numpoint);
            end;
      if nbpoints>maxnbpoints
      then maxnbpoints:=nbpoints;
      if length(arbrecour)=0
      then begin
           longanc:=longanc div (nbpointstot*maxnbpoints);
           nbpointstot:=length(arbresuiv);
           inc(niveau);
           arbrecour:=arbresuiv;
           arbresuiv:='';
           end;
      end
until length(arbrecour)=0;
if not errors
then setpointershape(sablier3);
setcolor(white);
centre_texte(0,440,639,450,'Arbre obtenu par B.F.S. : '+arbretot);
end;

(***************************** connexite ************************************)
function connexe(g:graphe):boolean;
{connexit d'un graphe}
var i,j,k:vertex;
    ok:boolean;
begin
for i:='a' to 'z' do
    for j:='a' to 'z' do
        if g.mat[i,j] and g.mat[j,i]
        then for k:='a' to 'z' do
                 if g.mat[k,k]
                 then if g.mat[i,k] or g.mat[k,i] or g.mat[j,k] or g.mat[k,j]
                      then begin
                           g.mat[i,k]:=true;
                           g.mat[k,i]:=true;
                           g.mat[j,k]:=true;
                           g.mat[k,j]:=true;
                           end;
j:='a';
ok:=false;
repeat
      begin
      if g.mat[j,j]
      then ok:=true
      else j:=succ(j);
      end
until ok;
for i:='a' to 'z' do
    if g.mat[i,i]
    then if not g.mat[j,i]
         then ok:=false;
connexe:=ok;
end;


(***************************** KRUSKAL **************************************)
procedure kruskal(g:graphe);
var arcs:array [1..325,1..2] of vertex;
    poids,compteur2,compteur:integer;
    x,y,a,b:vertex;
    ok:boolean;
begin
if not errors
then setpointershape(sablier1);
for compteur:=1 to 325 do      (* initialisation avant tri des arcs *)
    begin
    arcs[compteur,1]:='a';
    arcs[compteur,2]:='a';
    end;
poids:=0;
compteur:=0;
for x:='a' to 'z' do
    g.mat[x,x]:=false;
ok:=true;
while ok do                    (* tri des arcs en ordre croissant de poids *)
      begin;
      ok:=false;
      for x:='a' to 'z' do
          for y:='a' to 'z' do
              if g.mat[x,y] and (x<y)
              then begin
                   ok:=true;
                   if g.mat_poids[x,y]=poids
                   then begin
                        inc(compteur);
                        arcs[compteur,1]:=x;
                        arcs[compteur,2]:=y;
                        g.mat[x,y]:=false;
                        g.mat[y,x]:=false;
                        end;
                   end;
      inc(poids);
      end;                               (* fin du tri des arcs *)
for compteur2:=1 to compteur do             (* debut kruskal *)
    begin
    if (compteur2=compteur div 3) and not errors
    then setpointershape(sablier2);
    if (compteur2=(compteur div 3)*2) and not errors
    then setpointershape(sablier3);
    if not g.mat[arcs[compteur2,1],arcs[compteur2,2]]
    then begin
         g.mat[arcs[compteur2,1],arcs[compteur2,2]]:=true;
         g.mat[arcs[compteur2,2],arcs[compteur2,1]]:=true;
         arete_epaisse(g,arcs[compteur2,1],arcs[compteur2,2]);
         for a:='a' to 'z' do
             for b:='a' to 'z' do
                 if g.mat[a,b] or g.mat[b,a]
                 then for x:='a' to 'z' do
                      if g.mat[a,x] or g.mat[x,a] or g.mat[b,x] or g.mat[x,b]
                      then begin
                           g.mat[a,x]:=true;
                           g.mat[x,a]:=true;
                           g.mat[b,x]:=true;
                           g.mat[x,b]:=true;
                           end;
         end;
    end;                             (* fin kruskal *)
end;

(****************************************************************************)
PROCEDURE init_pred(var p:predecesseur;g:graphe;racine:vertex);
var w:vertex;
BEGIN
FOR w:='a' TO CHR(96+g.maxsom) DO
    BEGIN
    p[w].som:='0';
    p[w].pds:=0;
    END;
p[racine].som:=racine;
p[racine].pds:=0
END;

(*************************  ALGORITHME DE DIJKSTRA  *************************)
(*************** RESULTATS:SOMMET COURANT MARQUE,POIDS MARQUE ***************)
PROCEDURE DIJKSTRA(g:graphe;racine:vertex);
var pred:predecesseur;
    s1,s2,rac_cour,min_som:vertex;
    arbre:string;
    new_poids,i,j,min,nbsom:INTEGER;
    appartient:BOOLEAN;

BEGIN
init_pred(pred,g,racine);
arbre:=racine;
rac_cour:=racine;
new_poids:=0;
nbsom:=0;
FOR s1:='a' TO 'z' DO
    IF g.mat[s1,s1]
    THEN nbsom:=nbsom+1;
WHILE length(arbre)<> nbsom DO
      BEGIN
      FOR s2:='a' TO CHR(96+g.maxsom) DO
          BEGIN
          appartient:=FALSE;
          FOR i:=1 TO length(arbre) DO
              appartient:= appartient OR (arbre[i]=s2);
          IF g.mat[rac_cour,s2] AND NOT appartient
          THEN BEGIN
               new_poids:=g.mat_poids[rac_cour,s2] + pred[rac_cour].pds;
               IF pred[s2].som <> '0'
               THEN IF new_poids<pred[s2].pds
                    THEN BEGIN
                         pred[s2].pds:=new_poids;
                         pred[s2].som:=rac_cour
                         END
                    ELSE BEGIN
                         END
               ELSE BEGIN
                    pred[s2].pds:=new_poids;
                    pred[s2].som:=rac_cour
                    END
               END
          END;
      min:=maxint;
      FOR s2:='a' TO CHR(96+g.maxsom) DO
          BEGIN
          appartient:=FALSE;
          FOR i:=1 TO length(arbre) DO
              appartient:= appartient OR (arbre[i]=s2);
          IF ((pred[s2].som<>'0') AND (NOT appartient))
          THEN IF (pred[s2].pds < min)
               THEN BEGIN
                    min:=pred[s2].pds;
                    min_som:=s2
                    END
          END;
      arbre:=arbre+min_som;
      arete_epaisse(g,pred[min_som].som,min_som);
      rac_cour:=min_som
      END
END;


(*************************** ALGORITHME DE PRIM *****************************)
(***** VERIFIER SI CONNEXE;RESULTATS;SOMMET COURANT MARQUE,POIDS MARQUE *****)

PROCEDURE prim(g:graphe;racine:vertex);
var pred:predecesseur;
    s1,s2,rac_cour,min_som:vertex;
    arbre:string;
    min,i,nbsom:integer;
    appartient:BOOLEAN;
BEGIN
arbre:=racine;
init_pred(pred,g,racine);
rac_cour:=racine;
FOR s1:='a' TO CHR(96+g.maxsom) DO
    IF s1<>racine
    THEN IF g.mat[racine,s1]
         THEN BEGIN
              pred[s1].pds:=g.mat_poids[racine,s1];
              pred[s1].som:=racine
              END
         ELSE BEGIN
              pred[s1].pds:=maxint;
              pred[s1].som:=racine
              END;
nbsom:=0;
FOR s1:='a' TO 'z' DO
    IF g.mat[s1,s1]
    THEN nbsom:=nbsom+1;
WHILE (length(arbre)<>nbsom) DO
      BEGIN
      min:=maxint;
      FOR s2:='a' TO CHR(96+g.maxsom) DO
          BEGIN
          appartient:=FALSE;
          FOR i:=1 TO length(arbre) DO
              appartient:= appartient OR (arbre[i]=s2);
          IF ((pred[s2].som<>'0') AND (NOT appartient))
          THEN IF ((pred[s2].pds < min) AND (pred[s2].pds<>0))
               THEN BEGIN
                    min:=pred[s2].pds;
                    min_som:=s2
                    END
          END;
      arbre:=arbre+min_som;
      arete_epaisse(g,pred[min_som].som,min_som);
      rac_cour:=min_som;
      FOR s2:='a' TO CHR(96+g.maxsom) DO
          BEGIN
          appartient:=FALSE;
          FOR i:=1 TO length(arbre) DO
              appartient:= (appartient OR (arbre[i]=s2));
          IF g.mat[rac_cour,s2] AND NOT appartient
          THEN IF g.mat_poids[rac_cour,s2]<pred[s2].pds
               THEn BEGIN
                    pred[s2].pds:=g.mat_poids[rac_cour,s2];
                    pred[s2].som:=rac_cour
                    END
          END
      END;
END;


(******************************* PROGRAMME PRINCIPAL ************************)
var buttons,horiz,vert:word;
 quitter,quitterb,creerb,ajoutb,enlevb,dfsb,bfsb,krusb,poidsb,retraceb,
 infob,depsomb,ajarcb,enlevarcb,primb,dijkb,ok,ok2:boolean;
 a:char;
 g:graphe;
 racine,i,l1,l2:vertex;
 poids:integer;

begin
quitter:=false;
quitterb:=false;
creerb:=false;
ajoutb:=false;
enlevb:=false;
dfsb:=false;
bfsb:=false;
krusb:=false;
poidsb:=false;
retraceb:=false;
infob:=false;
tracepoids:=true;
depsomb:=false;
ajarcb:=false;
enlevarcb:=false;
primb:=false;
dijkb:=false;

initgraphic;
initecran;
initmouse(buttons,errors);

if not errors
then begin
  setmousesense(32,64,64);
  setmouseintr(16);
  setmouselang(1);
  stdptr:=true;
  showpointer;
  setpointerposition(320,200);
  end;
randomize;
info;
repeat
  ok2:=false;
  for i:='a' to 'z' do
      if g.mat[i,i]
      then ok2:=true;
  if (infob and buttonpressed(7))
  then info;
  if (creerb and buttonpressed(7))
  then begin
      setpointershape(main2);
      delay(250);
      setpointershape(main);
      delay(250);
      setpointershape(sablier1);
      creer_graphe(g);
      dessiner_graphe(g);
      setpointershape(main);
      end;
  if (ajoutb and buttonpressed(7))
  then begin
      setpointershape(main2);
      delay(250);
      setpointershape(main);
      delay(250);
      setpointershape(sablier1);
      repeat
            demander('Nom du sommet  crer (a..z) :',racine);
      until not g.mat[racine,racine];
      setpointershape(reticule);
      barre_info('Slectionnez la place du sommet  ajouter...');
      setpointerposition(50,45);
      repeat
            if buttonpressed(7) and mousein(10,59,628,448)
            then begin
                getmouseposition(buttons,horiz,vert);
                g.mat[racine,racine]:=true;
                g.abs[racine]:=horiz;
                g.ord[racine]:=vert;
                if (g.maxsom=0) or (racine>chr(96+g.maxsom))
                then g.maxsom:=ord(racine)-96;
                dessiner_graphe(g);
                quitter:=true;
                end
            else if (mousein(40,25,59,43) and buttonpressed(7))
                 then quitter:=true;
      until quitter;
      quitter:=false;
      ajoutb:=false;
      stdptr:=true;
      barre_info('');
      setpointershape(standard);
      setpointerposition(50,45);
      end;
  if (enlevb and buttonpressed(7) and ok2)
  then begin
      setpointershape(main2);
      delay(250);
      setpointershape(main);
      delay(250);
      setpointershape(reticule);
      barre_info('Slectionnez un ou plusieurs sommet(s)  dtruire...');
      setpointerposition(70,45);
      repeat
            if (mousein(10,59,628,448) and buttonpressed(7))
            then begin
                getmouseposition(buttons,horiz,vert);
(**)                quitter:=true;
                for l1:='a' to 'z' do
                    if g.mat[l1,l1]
                    then if (g.abs[l1]>=horiz-5)
                            and (g.abs[l1]<=horiz+5)
                         then if (g.ord[l1]>=vert-5)
                                 and (g.ord[l1]<=vert+5)
                              then begin
                                  for l2:='a' to 'z' do
                                     begin
                                      g.mat[l1,l2]:=false;
                                      g.mat[l2,l1]:=false;
                                      g.mat_poids[l1,l2]:=0;
                                      g.mat_poids[l2,l1]:=0
                                      end;
                                  g.ord[l1]:=0;
                                  g.abs[l1]:=0;
                                  g.mat[l1,l1]:=false;
                                  end;
                dessiner_graphe(g);
                end
            else if (mousein(61,25,80,43) and buttonpressed(7))
                 then quitter:=true
      until quitter;
      quitter:=false;
      enlevb:=false;
      stdptr:=true;
      barre_info('');
      setpointershape(standard);
      setpointerposition(70,45);
      end;
  if (depsomb and buttonpressed(7) and ok2)
  then begin
      setpointershape(main2);
      delay(250);
      setpointershape(main);
      delay(250);
      setpointershape(reticule);
      barre_info('Slectionnez un sommet  dplacer...');
      setpointerposition(110,45);
      repeat
           if (mousein(10,59,628,448) and buttonpressed(7))
           then begin
               quitter:=true;
               getmouseposition(buttons,horiz,vert);
               for l1:='a' to 'z' do
                  if g.mat[l1,l1]
                  then if (g.abs[l1]>=horiz-5)
                          and (g.abs[l1]<=horiz+5)
                       then if (g.ord[l1]>=vert-5)
                               and (g.ord[l1]<=vert+5)
                            then begin
                                ok:=false;
                                barre_info('Dplacez le sommet o vous le dsirez...');
                                repeat
                                     if (mousein(10,59,628,448)
                                        and buttonpressed(7))
                                     then begin
                                         getmouseposition(buttons,horiz,vert);
                                         g.ord[l1]:=vert;
                                         g.abs[l1]:=horiz;
                                         end
                                     else if not buttonpressed(7)
                                          then ok:=true;
                                     dessiner_graphe(g);
                                until ok;
                                barre_info('Slectionnez un sommet  dplacer...');
                                end;
               end
           else if (mousein(99,25,118,43) and buttonpressed(7))
                then quitter:=true;
      until quitter;
      quitter:=false;
      depsomb:=false;
      stdptr:=true;
      barre_info('');
      setpointershape(standard);
      setpointerposition(110,45);
      end;
  if (ajarcb and buttonpressed(7) and ok2)
  then begin
      setpointershape(main2);
      delay(250);
      setpointershape(main);
      delay(250);
      setpointershape(reticule);
      barre_info('Slectionnez le sommet "source"...');
      setpointerposition(130,45);
      repeat
        if buttonpressed(7) and mousein(10,59,628,448)
        then begin
            getmouseposition(buttons,horiz,vert);
            for l1:='a' to 'z' do
               if g.mat[l1,l1]
               then if (g.abs[l1]>=horiz-5)
                       and (g.abs[l1]<=horiz+5)
                   then if (g.ord[l1]>=vert-5)
                           and (g.ord[l1]<=vert+5)
                       then begin
                           barre_info('Slectionnez le sommet "destination"...');
                           repeat
                             if (mousein(10,59,628,448)
                                and buttonpressed(7))
                             then begin
                                 getmouseposition(buttons,horiz,vert);
                                 for l2:='a' to 'z' do
                                    if g.mat[l2,l2]
                                    then if (g.abs[l2]>=horiz-5)
                                            and (g.abs[l2]<=horiz+5)
                                       then if (g.ord[l2]>=vert-5)
                                               and (g.ord[l2]<=vert+5)
                                         then if l2<>l1
                                             then begin
                                               g.mat[l1,l2]:=true;
                                               g.mat[l2,l1]:=true;
                                               demander_poids('Entrez le poids de l''arc :',poids);
                                               g.mat_poids[l1,l2]:=poids;
                                               g.mat_poids[l2,l1]:=poids;
                                               dessiner_graphe(g);
                                               quitter:=true;
                                               horiz:=0;
                                               vert:=0;
                                               end
                                             else begin
                                                  end
                                         else begin
                                              end
                                       else begin
                                            end
                                    else begin
                                         end
                                 end
                           until quitter;
                           quitter:=false;
                           barre_info('Slectionnez le sommet "source"...');
                           end;
            quitter:=true;
            end
        else if (mousein(120,25,139,43) and buttonpressed(7))
             then quitter:=true;
      until quitter;
      quitter:=false;
      ajarcb:=false;
      stdptr:=true;
      barre_info('');
      setpointershape(standard);
      setpointerposition(130,45);
      end;
  if (enlevarcb and buttonpressed(7) and ok2)
  then begin
      setpointershape(main2);
      delay(250);
      setpointershape(main);
      delay(250);
      setpointershape(reticule);
      barre_info('Slectionnez le sommet "source"...');
      setpointerposition(150,45);
      repeat
        if buttonpressed(7) and mousein(10,59,628,448)
        then begin
            getmouseposition(buttons,horiz,vert);
            for l1:='a' to 'z' do
               if g.mat[l1,l1]
               then if (g.abs[l1]>=horiz-5)
                       and (g.abs[l1]<=horiz+5)
                   then if (g.ord[l1]>=vert-5)
                           and (g.ord[l1]<=vert+5)
                       then begin
                           barre_info('Slectionnez le sommet "destination"...');
                           repeat
                             if (mousein(10,59,628,448)
                                and buttonpressed(7))
                             then begin
                                 getmouseposition(buttons,horiz,vert);
                                 for l2:='a' to 'z' do
                                    if g.mat[l2,l2]
                                    then if (g.abs[l2]>=horiz-5)
                                            and (g.abs[l2]<=horiz+5)
                                       then if (g.ord[l2]>=vert-5)
                                               and (g.ord[l2]<=vert+5)
                                         then if l2<>l1
                                             then begin
                                               g.mat[l1,l2]:=false;
                                               g.mat[l2,l1]:=false;
                                               g.mat_poids[l2,l1]:=0;
                                               g.mat_poids[l1,l2]:=0;
                                               dessiner_graphe(g);
                                               quitter:=true;
                                               horiz:=0;
                                               vert:=0;
                                               end
                                             else begin
                                                  end
                                         else begin
                                              end
                                       else begin
                                            end
                                    else begin
                                         end
                                 end
                           until quitter;
                           quitter:=false;
                           barre_info('Slectionnez le sommet "source"...');
                           end;
            quitter:=true;
            end
        else if (mousein(141,25,160,43) and buttonpressed(7))
             then quitter:=true;
      until quitter;
      quitter:=false;
      enlevarcb:=false;
      stdptr:=true;
      barre_info('');
      setpointershape(standard);
      setpointerposition(150,45);
      end;
  if (dfsb and buttonpressed(7) and ok2)
  then begin
      setpointershape(unbis);
      delay(250);
      setpointershape(un);
      delay(250);
       dessiner_graphe(g);
       demander('Racine de l''arbre D.F.S. (a..z) : ',racine);
       dfs_recursif(g,racine);
       setpointershape(main);
       end;
  if (bfsb and buttonpressed(7) and ok2)
  then begin
      setpointershape(zero);
      delay(250);
      setpointershape(deux);
      delay(250);
       demander('Racine de l''arbre B.F.S. (a..z) : ',racine);
       bfs(g,racine);
       setpointershape(main);
       end;
  if (krusb and buttonpressed(7) and ok2)
  then (*if connexe(g)
       then*) begin
            setpointershape(zero);
            delay(250);
            setpointershape(trois);
            delay(250);
            dessiner_graphe(g);
            kruskal(g);
            setpointershape(main);
            end;
       (*else barre_info('Le graphe courant n''est pas connexe...');*)
  if (primb and buttonpressed(7) and ok2)
  then if connexe(g)
       then begin
            setpointershape(zero);
            delay(250);
            setpointershape(quatre);
            delay(250);
            dessiner_graphe(g);
            demander('Racine de l''arbre de Prim (a..z) : ',racine);
            prim(g,racine);
            setpointershape(main);
            end
       else barre_info('Le graphe courant n''est pas connexe...');
  if (dijkb and buttonpressed(7) and ok2)
  then begin
       setpointershape(zero);
       delay(250);
       setpointershape(cinq);
       delay(250);
       dessiner_graphe(g);
       demander('Racine de l''arbre de Dijkstra (a..z) : ',racine);
       dijkstra(g,racine);
       setpointershape(main);
       end;
  if (poidsb and buttonpressed(7))
  then begin
       setpointershape(main2);
       delay(250);
       setpointershape(main);
       delay(250);
       setpointershape(sablier2);
       tracepoids:=not tracepoids;
       dessiner_graphe(g);
       setpointershape(main);
       if tracepoids
       then barre_info('Allumer/Eteindre l''affichage des poids des arcs (ON actuellement)...')
       else barre_info('Allumer/Eteindre l''affichage des poids des arcs (OFF actuellement)...');
       end;
  if (retraceb and buttonpressed(7))
  then begin
       setpointershape(main2);
       delay(250);
       setpointershape(main);
       delay(250);
       setpointershape(sablier2);
       dessiner_graphe(g);
       setpointershape(main);
       end;
  if keypressed
  then begin
       a:=upcase(readkey);
       case a of
           'Q':quit(quitter);
           'I':info;
           'C':begin
               creer_graphe(g);
               dessiner_graphe(g);
               end;
           'E':begin
               demander('Entrez le nom du sommet  dtruire :',l1);
               if g.mat[l1,l1]
               then begin
                    for l2:='a' to 'z' do
                        begin
                        g.mat[l1,l2]:=false;
                        g.mat[l2,l1]:=false;
                        g.mat_poids[l2,l1]:=0;
                        g.mat_poids[l1,l2]:=0
                        end;
                    g.mat[l1,l1]:=false;
                    g.ord[l1]:=0;
                    g.abs[l1]:=0;
                    dessiner_graphe(g);
                    end;
               end;
           'D':begin
               demander('Racine de l''arbre D.F.S. (a..z) : ',racine);
               dfs_recursif(g,racine);
               end;
           'B':begin
               demander('Racine de l''arbre B.F.S. (a..z) : ',racine);
               bfs(g,racine);
               end;
           'J':begin
               demander('Racine de l''arbre de Dijkstra (a..z) : ',racine);
               dijkstra(g,racine);
               end;
           'P':begin
               if connexe(g)
               then begin
                    demander('Racine de l''arbre de Prim (a..z) : ',racine);
                    prim(g,racine);
                    end
               else barre_info('Le graphe courant n''est pas connexe...');
               end;
           'R':dessiner_graphe(g);
           'K':(*if connexe(g)
               then*) begin
                    dessiner_graphe(g);
                    kruskal(g)
                    end;
               (*else barre_info('Le graphe courant n''est pas connexe...');*)
           'M':begin
               tracepoids:=not tracepoids;
               dessiner_graphe(g);
               end;
           end;
       end;
  if not errors
  then if mousein(0,0,19,19)
    then if not quitterb
         then begin
              quitterb:=true;
              setpointershape(fleche_gauche);
              stdptr:=false;
              barre_info('Quitter Gaston Le Grapheur...');
              end
         else begin
              end
    else if mousein(620,0,639,19)
      then if not infob
           then begin
                infob:=true;
                setpointershape(fleche_droite);
                stdptr:=false;
                barre_info('Au sujet de Gaston Le Grapheur...');
                end
           else begin
                end
      else if mousein(19,25,38,43)
        then if not creerb
             then begin
                  creerb:=true;
                  setpointershape(main);
                  stdptr:=false;
                  barre_info('Creer un graphe au hazard...');
                  end
             else begin
                  end
        else if mousein(40,25,59,43)
          then if not ajoutb
               then begin
                    ajoutb:=true;
                    setpointershape(main);
                    stdptr:=false;
                    barre_info('Ajouter un sommet au graphe...');
                    end
               else begin
                    end
          else if mousein(61,25,80,43)
            then if not enlevb
                 then begin
                      enlevb:=true;
                      setpointershape(main);
                      stdptr:=false;
                      barre_info('Enlever un sommet au graphe...');
                      end
                 else begin
                      end
            else if mousein(99,25,118,43)
              then if not depsomb
                   then begin
                        depsomb:=true;
                        setpointershape(main);
                        stdptr:=false;
                        barre_info('Dplacer un sommet du graphe...');
                        end
                   else begin
                        end
              else if mousein(120,25,139,43)
                then if not ajarcb
                     then begin
                          ajarcb:=true;
                          setpointershape(main);
                          stdptr:=false;
                          barre_info('Ajouter un arc au graphe / Modifier le poids d''un arc...');
                          end
                     else begin
                          end
                else if mousein(141,25,160,43)
                  then if not enlevarcb
                       then begin
                            enlevarcb:=true;
                            setpointershape(main);
                            stdptr:=false;
                            barre_info('Enlever un arc au graphe...');
                            end
                       else begin
                            end
                  else if mousein(183,25,223,43)
                    then if not dfsb
                         then begin
                              dfsb:=true;
                              setpointershape(un);
                              stdptr:=false;
                              barre_info('Appliquer l''algorithme D.F.S. au graphe...');
                              end
                         else begin
                              end
                    else if mousein(225,25,265,43)
                      then if not bfsb
                           then begin
                                bfsb:=true;
                                setpointershape(deux);
                                stdptr:=false;
                                barre_info('Appliquer l''algorithme B.F.S. au graphe...');
                                end
                           else begin
                                end
                      else if mousein(267,25,307,43)
                        then if not krusb
                             then begin
                                  krusb:=true;
                                  setpointershape(trois);
                                  stdptr:=false;
                                  barre_info('Appliquer l''algorithme de Kruskal au graphe...');
                                  end
                             else begin
                                  end
                        else if mousein(309,25,349,43)
                          then if not primb
                               then begin
                                    primb:=true;
                                    setpointershape(quatre);
                                    stdptr:=false;
                                    barre_info('Appliquer l''algorithme de Prim au graphe...');
                                    end
                               else begin
                                    end
                          else if mousein(351,25,391,43)
                            then if not dijkb
                                 then begin
                                      dijkb:=true;
                                      setpointershape(cinq);
                                      stdptr:=false;
                                      barre_info('Appliquer l''algorithme de Dijkstra au graphe...');
                                      end
                                 else begin
                                      end
                            else if mousein(504,25,551,43)
                              then if not poidsb
                                then begin
                                  poidsb:=true;
                                  setpointershape(main);
                                  stdptr:=false;
                                  if tracepoids
                                  then barre_info('Allumer/Eteindre l''affichage des poids des arcs (ON actuellement)...')
                                  else barre_info('Allumer/Eteindre l''affichage des poids des arcs (OFF actuellement)...');
                                  end
                                else begin
                                     end
                              else if mousein(553,25,620,43)
                                then if not retraceb
                                  then begin
                                    retraceb:=true;
                                    setpointershape(main);
                                    stdptr:=false;
                                    barre_info('Retracer le graphe courant...');
                                    end
                                  else begin
                                       end
         else if not stdptr then
                begin
                  setpointershape(standard);
                  stdptr:=true;
                  if quitterb then begin
                                   barre_info('');
                                   quitterb:=false;
                                 end;
                  if creerb then begin
                                   barre_info('');
                                   creerb:=false;
                                 end;
                  if ajoutb then begin
                                   barre_info('');
                                   ajoutb:=false;
                                 end;
                  if enlevb then begin
                                   barre_info('');
                                   enlevb:=false;
                                 end;
                  if depsomb then begin
                                    barre_info('');
                                    depsomb:=false;
                                  end;
                  if ajarcb then begin
                                   barre_info('');
                                   ajarcb:=false;
                                 end;
                  if enlevarcb then begin
                                      barre_info('');
                                      enlevarcb:=false;
                                    end;
                  if dfsb then begin
                                   barre_info('');
                                   dfsb:=false;
                                 end;
                  if bfsb then begin
                                   barre_info('');
                                   bfsb:=false;
                                 end;
                  if krusb then begin
                                   barre_info('');
                                   krusb:=false;
                                 end;
                  if primb then begin
                                   barre_info('');
                                   primb:=false;
                                 end;
                  if dijkb then begin
                                   barre_info('');
                                   dijkb:=false;
                                 end;
                  if poidsb then begin
                                   barre_info('');
                                   poidsb:=false;
                                 end;
                  if retraceb then begin
                                   barre_info('');
                                   retraceb:=false;
                                 end;
                  if infob then begin
                                   barre_info('');
                                   infob:=false;
                                 end;
                end;
    if (quitterb and buttonpressed(7))
      then quit(quitter);
until quitter;
closegraph;
writeln('Merci d''avoir utilis GASTON LE GRAPHEUR V2.0');
writeln('(C)opyright 1994 B&B&C SoftWare Corporation Ltd');
end.