{
     You should use Turbo/Borland Pascal 7+ to compile/run this program.
      There's a good chance it will work with previous versions though.


   Here's a little program I through together in about 10 minutes that
   plays VOC (voice) files. If it took me any longer to write this (besides
   comments) I wouldn't give it away but since it's simple and I don't like
   to play games without SB support I figured Why Not!

   This program loads up the "CT-VOICE.DRV" file that comes standard with
   your sound blaster card and then initializes it (D.B. (initials - get it?)).

   After the initialization stuff it loops showing you the "status" word
   in different colors.

   To play a file press [1] or [2] but make sure you have the "CONGA.VOC"
   file and "CLOCK.VOC" file or you'll get an error.
   If you don't have those VOC files then change their names to whatever
   you do have so long as the file is less than 64,000 bytes (see note below).

   This program is FREEWARE (oh joy) so use it in your games and send me a
   copy of `em when your done.

   Send games to:
                 Deric Benesch
                 15 Inverness rd.
                 Holbrook, NY 11741-5015

   Thanks!


   P.S.- You could use "BINOBJ" to change the driver (CT-VOICE.DRV) into
         an object file (*.OBJ) then load it ($L FileName) and set up a
         procedure to call it (procedure PublicName; external;).
         But for now just use this code OK.


   P.P.S.- I've noticed that not all SB CT-VOICE drivers are created equal.
           I have SB16 and when I tried using my copy of CT*.DRV on SBPRO
           it did not work (oops). I haven't tried using SBPRO's CT*.DRV
           on my SB16 yet but I do own both SB16 and SBPRO so by the time
           this is on a BBS I would have tried it (but you'll never know,
           ha-ha-ha-ha-ha). You can drop me a letter at the above address
           about this issue (Please do NOT call) and I'll drop you a letter
           back with the results and any other info I may have.

   P.P.P.S.- I forgot to say that if you have SBPRO or earlier you need to
             use the CT-VOICE.DRV that came with your SB software. The
             driver I (may) have included with this program is the driver
             for SB16.
}
uses crt;

type
  buf = array[0..64000]of byte;
  proc = procedure;

var
  statusw: word;
  driver: ^buf;
  vocfile1: ^buf;
  f: file;
  numread: integer;
  error,
  vseg1,
  vofs1: word;
  staddr,
  vpoint1: pointer;

  ch: char;

begin
  textattr:=15;
  {
NOTE: the driver and voice file(s) you use must be less than
      sizeof(buf) stated above: "buf = array[0..64000]of byte;"
      or the program will crash.                ^^^^^
  }

  new(driver);          { Get memory for driver }
  new(vocfile1);        { Get memory for voice file #1 }


  {
    Loads the voice driver into driver^ so you can use it (duh).
    Make sure the driver is in the current directory or change the
    path below to where the driver is at.
    ex: 'C:\SB16\DRV\CT-VOICE.DRV'
  }
  assign(f,'CT-VOICE.DRV');
  reset(f,1);
  blockread(f,driver^,sizeof(buf),numread);
  close(f);

  {
    Below I used assembler to set up the variables/registers needed to
    interface with the CT-VOICE driver.
    I didn't initialize everything possible since I didn't need to, if you
    need more info on SB stuff pick up The Ultimate SOUNDBLASTER Book by
    QUE, or try Creative Labs BBS - (408) 428-6660 in California.

  --------------------------------------------------------------------------
                    * Initilization of the driver *

      Function #2
      Set DMA interrupt to 5 (SB16)
      If you have SBPRO or just SB then set it to 7
  }
  asm
    MOV  BX, 2          { Function #2 - Set DMA Interrupt }
    MOV  AX, 5          { Set DMA Int to 5 }
  end;
  proc(driver);         { Call driver }

  {
                    * Initilization of the driver *

      Function #3
      Initialize driver
  }
  asm
    MOV  BX, 3          { Function #3 - Initialize driver }
  end;
  proc(driver);         { Call driver }
  asm
    MOV  error, AX      { Check for any errors - should be 0 (no error) }
  end;
  writeln('Error = ',error);
  if error<>0 then      { If there was an error pause for a key }
  begin
    ch:=upcase(readkey);
    if ch in [#27,'N'] then halt;
  end;

  {
                    * Initilization of the driver *

      Function #5
      Tell driver where your status word is
  }
  staddr:=addr(statusw);
  asm
    MOV  BX, 5          { Function #5 - Set status word address }
    LES  DI, staddr     { Load address pointer into ES:DI registers }
  end;
  proc(driver);         { Call driver }


  repeat
    ch:='';
    if keypressed then ch:=upcase(readkey);
    if ch<>'' then
    begin
      if ch in ['1','2'] then
      begin
        {
                             :) Do something (:

            Function #8
            Shut up
            Stop voice (if any)
        }
        asm
          MOV  BX, 8          { Function #8 - Stop voice I/O }
        end;
        proc(driver);         { Call driver }
      end;

      case ch of '1':begin
                       { Loads the voice file so you can play it (duh). }
                       assign(f,'CONGA.VOC');  { You can change this name...
                                                       you know }
                       reset(f,1);
                       blockread(f,vocfile1^,sizeof(buf),numread);
                       close(f);

                       { WOW what a mess of stuff huh? }

                       { Get segment of VOC file in memory }
                       vseg1:=seg(vocfile1^);

                       { Extract VOC BLOCK offset location }
                       vofs1:=vocfile1^[21]*256 + vocfile1^[20];

                       { Debugging stuff left in here }
                       writeln('File offset = ',vofs1);

                       { Calculate offset of VOC BLOCK in memory }
                       vofs1:=vofs1+ofs(vocfile1^);

                       { Set up a pointer to point to VOC BLOCK }
                       vpoint1:=ptr(vseg1,vofs1);
                     end;
                 '2':begin
                       { Same as '1' }
                       assign(f,'CLOCK.VOC');  { You can change this name...
                                                       you know }
                       reset(f,1);
                       blockread(f,vocfile1^,sizeof(buf),numread);
                       close(f);

                       { You figure it out! }
                       vseg1:=seg(vocfile1^);
                       vofs1:=vocfile1^[21]*256 + vocfile1^[20];
                       writeln('File offset = ',vofs1);
                       vofs1:=vofs1+ofs(vocfile1^);
                       vpoint1:=ptr(vseg1,vofs1);
                     end;
                 end;

      if ch in ['1','2'] then
      begin
        {
                             :) Do something (:

            Function #6
            Start your voice!
        }
        asm
          MOV  BX, 6          { Function #6 - Start voice output }
          LES  DI, vpoint1    { Load the voice BLOCK location into ES:DI regs }
        end;
        proc(driver);         { Call driver }
        asm
          MOV  error, AX      { Check for any errors - should be 0 (no error) }
        end;
        writeln('Error = ',error);
        if error<>0 then      { If there was an error pause for a key }
        begin
          ch:=upcase(readkey);
          if ch in [#27,'N'] then halt;
        end;
      end;
    end;

    textattr:=random(14)+1; { Make random colors to keep you from sleeping }
    writeln(statusw);       { Show the status word,
                              0 if nothing is happening,
                              65535 if a voice is playing }
  until ch=#27;

  {
                       :) Do something (:

      Function #9
      Kill the driver
  }
  asm
    MOV  BX, 9          { Function #9 - Terminate Driver (I'll be baack) }
  end;
  proc(driver);         { Call driver }
end.